/*  builtin_ls()  for nic.funet.fi  ftp server */


#include <stdio.h>
#include <syslog.h>

extern int debug;
extern int guest;
extern char envPWD[];

extern int optind, opterr;
extern char *optarg;
extern int optopt;

#define ARGSTR "?ACFLPRXYZrgtacdfilnpqsux"

static int ls_f_recurse  = 0;
static int ls_f_long     = 0;
static int ls_f_reverse  = 0;
static int ls_f_group    = 0;
static int ls_f_ALL      = 0;
static int ls_f_all      = 0;
static int ls_f_ZZZ      = 0;
static int ls_f_timesort = 0;

static void ls_usage(optchar)
char optchar;
{
  fprintf(stderr,"builtin_ls: Known options: %s\n",ARGSTR);
}

int
builtin_ls(argc,argv)
int argc;
char *argv[];
{
	int c, cnt = 0;
	char *arg0 = argv[0];
	argv[0] = "builtin_ls";

	optind = 1;   /* We use same  optind  as main-program does,
		         reinit it back to begining.. */
	opterr = 1;   /* Enable error report one-liner */
	optarg = NULL;
	/* optopt = 0; ?? What is this variable ?? */

	if (guest)
		ls_f_ZZZ = 1;
	
	while (cnt++,(c = getopt(argc,argv,ARGSTR)) != -1)
	  switch (c) {
	    case 'l':
	        ls_f_long = 1;
		break;
	    case 'R':
		ls_f_recurse = 1;
		break;
	    case 'X': /* .FTP_LS_DATA -cache remake enable .. */
	    case 'Z':
		ls_f_ZZZ = 1;
		break;
	    case 'r':
		ls_f_reverse = 1;
		break;
	    case 'g':
		ls_f_group = 1;
		break;
	    case 'A':
		ls_f_ALL = 1;
	    case 'a':
		ls_f_all = 1;
		break;
	    case 't':
		ls_f_timesort = 1;
		break;
	    case '?':
	        ls_usage(c);
		fflush(stderr);
		exit(127);
	    default:
		break; /* Something unimplemented in the case statement.. */
	  }

	if (debug) syslog(LOG_DEBUG,"builtin_ls(%d,\"%s\",\"%s\",\"%s\",...) envPWD=\"%s\"",
			  argc,argv[0],argv[1],argv[2],envPWD);


	if (ls_f_recurse && ls_f_ZZZ && 
	    (strcmp(envPWD,"PWD=/") == 0 ||
	     strcmp(envPWD,"PWD=/pub") == 0)) {
	  printf("** Won't do recursive directory listing from anywhere above /pub/ -directory\n");
	  printf("** Please retrieve ready-made listing  (one of) /ls-* -files, if you really\n");
	  printf("** want to have our complete listing.\n");
	  printf("**\n");
	  printf("** Recursive listings/indexes of sub areas are available, but only after you\n");
	  printf("** CWD into said sub-directory.  Some sub-areas have their own recursive\n");
	  printf("** listings ready-made every night.\n");
	  exit(128);
	}

	argv[0] = arg0;	/* Restore argv[0] */
	exit( execv(argv[0],argv) );
	return 0;
}
