/* ================================================================

       CUSTomer LOCALITY.C	routines

   Some extensions to BSD (tahoe/reno) FTP server.

   By  Matti Aarnio <mea@nic.funet.fi>  Jan-1991
   Copyright (c) FUNET 1991

   By all means, use and adapt to your usage, but don't claim you
   invented it ;-)

   Should do this with configuration file - text file - without
   hard-coding things like this...  Some day when I have time..

   ================================================================ */

/* <<<<<<<<<<<<<<<< NOT REALLY FINISHED ! >>>>>>>>>>>>>>>> */

#define CUST_MAIN
#include <stdio.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/stat.h>
#include <netdb.h>
#include <syslog.h>
#include "syslog-vals.h"
#include "custlocality.h"	/* CUST_ enumerations */

#ifndef	__STDC__
#define const /* Doesn't know const .. */
#endif

extern char *strtok(), *strdup();
extern int debug;
extern void upper ();
char *PATH = NULL;

extern char *ClassReadme;

static FILE *LocalityInfo = NULL;

typedef struct RegionStruct {
  struct RegionStruct *next;
  int   deny_allow;
  int   plen;
  char *pattern;
  char *comment;
} RegionStruct;

typedef struct {
  char *userid;
  struct in_addr haddr;
  char *domain;
  CUST_LOCALITY loc;
  int maxsendrate;
  int absmaxsendrate;
  int maxanonymous;
  RegionStruct *region;
  char *ClassReadme;
} LocalityRecord;

struct Virtuals {
  struct in_addr haddr;
  char *chrootdir;
  char *chdirdir;
};

static LocalityRecord  * Localities = NULL;
static RegionStruct    * RegionHead = NULL;
static int               loclcnt = 0;
static CUST_LOCALITY     loc     = CUST_low;
static struct Virtuals * Virtuals = NULL;
static int VirtualsCount = 0, VirtualsSpace = 0;


extern void *malloc(), *realloc();
extern int strlen();

static void
add_to_Banner200(banp,line)
Banner200 **banp;
char *line;
{
	char *lin2      = malloc(strlen(line)+1);
	Banner200 *ban, *ban2;

	strcpy(lin2,line);

	ban2 = (Banner200*) malloc(sizeof(Banner200));
	ban2->line = lin2;
	ban2->next = NULL;

	if (*banp == NULL)
	  *banp = ban2;
	else {
	  ban = *banp;

	  while (ban->next)	/* Go forward until on last line so far */
	    ban = ban->next;

	  ban->next = ban2;	/* Tag new line to previous last one */
	}
}

void
delete_Banner200(banp)
Banner200 **banp;
{
	char *lin;
	Banner200 *bp, *bp2;
	bp = *banp;
	while(bp != NULL) {
	  bp2 = bp->next;
	  if (bp->line != NULL) free(bp->line);
	  free(bp);
	  bp = bp2;
	}
	*banp = NULL;
}

static const char *localityname = NULL;
static struct stat localityStat;

void
RefreshCustLocality(forced)
int forced;
{
	struct stat stb;
	if (localityname == NULL) return; /* ?? */
	if (stat(localityname,&stb) < 0) return;
	if (forced ||
	    localityStat.st_size  != stb.st_size  ||
	    localityStat.st_mtime != stb.st_mtime ||
	    localityStat.st_ino   != stb.st_ino   ||
	    localityStat.st_ctime != stb.st_ctime    ) {
	  /* Free the previous data... */
	  int i;
#define CFREE(x) if ((x) != NULL) { free(x); x = NULL; }
	  for (i = 0; i < loclcnt; ++i) {
	    CFREE(Localities[i].userid);
	    CFREE(Localities[i].ClassReadme);
	    CFREE(Localities[i].domain);
	    /* XX: More things to free.. */
	  }
	  free(Localities);
	  Localities = NULL;
	  RegionHead = NULL;
	  loclcnt = 0;
	  loc = CUST_low;
	  delete_Banner200(&banner220);
	  delete_Banner200(&banner221);
	  delete_Banner200(&banner230);

	  /* .. and just re-read it in. */
	  if (LocalityInfo != NULL)
	    fclose(LocalityInfo);
	  LocalityInfo = NULL;
	  InitCustLocality(localityname);
	}
	/* If no changes, we are happy.. */
}

void
InitCustLocality(localityfilename)
const char *localityfilename;
{
	int maxrate = 1024*1024;
	int absmaxrate = 1024*1024;
	int linenum = 0;
	int loclspace = 0;
	int newmaxanonymous = 0;
	int maxanon = maxanonymous;
	int i;
	char *s;
	char *sep = " \t\n";
	char *classname;
	char *classreadme = NULL;
	char buf[1000];
	char *Userid = strdup("*");


	localityname = localityfilename;


	Maxanonymous[CUST_FOREIGN] = 12;

	LocalityInfo = fopen(localityfilename,"r");

	maxanonymoussum = 0;
	for (i = CUST_low; i <= CUST_high; ++i) {
	  Maxanonymous[i] = maxanonymous;
	  Maxsendrate[i] = maxrate;
	  Absmaxsendrate[i] = absmaxrate;
	}

	if (!LocalityInfo) goto out_out;
	/* Well, silently quit if no configuration
	   Will give SOME service altough not very
	   intelligent..  */

	fstat(fileno(LocalityInfo),&localityStat);

	while(!feof(LocalityInfo) && !ferror(LocalityInfo)) {
	  ++linenum;
	  if (NULL == fgets(buf,sizeof(buf)-2,LocalityInfo)) break;
	  buf[sizeof(buf)-1] = 0;
	  s = strtok(buf,sep);
	  if (!s || *s == 0 || *s == '#' || *s == ';' || *s == '*') continue;

	  if (strcasecmp(s,"userid")==0) {
	    if (!(s = strtok(NULL,sep))) {
	      syslog(LOG_ALERT,"Parsing configuration file \"%s\"'s userid entry failed on line %d.",localityfilename,linenum);
	      continue;		/* missing param.. */
	    }
	    if (Userid) free(Userid);
	    Userid = strdup(s);
	  }
	  if (strcasecmp(s,"locality")==0) {
	    LocalityEnumerationType *LE = LocalityEnumerations;
	    if (!(s = strtok(NULL,sep))) {
	      syslog(LOG_ALERT,"Parsing configuration file \"%s\"'s locality entry failed on line %d.",localityfilename,linenum);
	      continue;		/* missing param.. */
	    }
	    while(LE->locname) {
	      if (strcasecmp(LE->locname,s)==0) break; /* Found! */
	      ++LE;
	    }
	    /* If not found, locality is FOREIGN! */
	    loc = LE->loc;
	    classname = strtok(NULL,"\t#;\n");
	    if (classname)
	      classname = strdup(classname);
	    ClassName[loc] = classname;
	    continue;
	  }
	  if (strcasecmp(s,"maxanonymous")==0) {
	    s = strtok(NULL,sep);
	    if (!s || 1!=sscanf(s,"%d",&maxanon)) {
	      syslog(LOG_ALERT,"Parsing configuration file \"%s\"'s MaxAmonymous def. failed on line %d.",localityfilename,linenum);
	      break;		/* failed */
	    }
	    /* The sum shall NOT exceed  MAX_FTMP, however safe
	       minimum shall be 1 for a class..  */
	    if (newmaxanonymous+maxanon > MAX_FTMP-10) {
	      maxanon = MAX_FTMP - 10 - newmaxanonymous;
	      if (maxanon < 1) maxanon = 1;
	    }
	    Maxanonymous[loc] = maxanon;
	    newmaxanonymous += maxanon;
	    continue;
	  }
	  if (strcasecmp(s,"absmaxsendrate")==0) {
	    s = strtok(NULL,sep);
	    if (!s || 1 != sscanf(s,"%d",&absmaxrate)) {
	      syslog(LOG_ALERT,"Parsing configuration file \"%s\"'s AbsMaxSendRate def. failed on line %d.",localityfilename,linenum);
	      break;		/* failed.. */
	    }
	    Absmaxsendrate[loc] = absmaxrate;
	    continue;
	  }
	  if (strcasecmp(s,"maxsendrate")==0) {
	    s = strtok(NULL,sep);
	    if (!s || 1 != sscanf(s,"%d",&maxrate)) {
	      syslog(LOG_ALERT,"Parsing configuration file \"%s\"'s MaxSendRate def. failed on line %d.",localityfilename,linenum);
	      break;		/* failed.. */
	    }
	    Maxsendrate[loc] = maxrate;
	    continue;
	  }
	  if (strcasecmp(s,"net")==0) {
	    struct in_addr haddr;
	    s = strtok(NULL,sep);
	    if (s) haddr.s_addr = inet_addr(s);
	    if (!s || haddr.s_addr == 0xFFFFFFFF) {
	      syslog(LOG_ALERT,"Parsing configuration file \"%s\"'s net number entry failed on line %d.",localityfilename,linenum);
	      continue;		/* Fail */
	    }
	    if (!Localities) {
	      Localities = (LocalityRecord*) malloc(sizeof(LocalityRecord)*8);
	      if (!Localities) {
		syslog(LOG_CRIT,"Malloc failed in InitCustLocality()");
		exit(90);
	      }
	      loclspace = 6;
	      loclcnt = 0;
	    } else if (loclcnt >= loclspace) {
	      loclspace += 8;
	      Localities = (LocalityRecord*) realloc(Localities,
						     sizeof(LocalityRecord) *
						     loclspace);
	      if (!Localities) {
		syslog(LOG_CRIT,"Realloc failed in InitCustLocality()");
		exit(90);	/* Realloc failed.. */
	      }
	    }
	    Localities[loclcnt].userid			= strdup(Userid);
	    Localities[loclcnt].loc			= loc;
	    Localities[loclcnt].haddr			= haddr;
	    Localities[loclcnt].domain			= NULL;
	    Localities[loclcnt].region			= RegionHead;
	    Localities[loclcnt].ClassReadme		= strdup(classreadme ?
								 classreadme :
								 "");
	    Localities[loclcnt].maxsendrate		= maxrate;
	    Localities[loclcnt].absmaxsendrate		= absmaxrate;
	    Localities[loclcnt].maxanonymous		= maxanon;
	    ++loclcnt;
	    continue;
	  }

	  if (strcasecmp(s,"domain")==0) {
	    char *domain;

	    domain = strtok(NULL,sep);
	    if (!domain) {
	      syslog(LOG_ALERT,"Parsing configuration file \"%s\"'s domain entry failed on line.",localityfilename,linenum);
	      continue;		/* Fail */
	    }
	    if (!Localities) {
	      Localities = (LocalityRecord*) malloc(sizeof(LocalityRecord)*8);
	      if (!Localities) {
		syslog(LOG_CRIT,"Malloc failed in InitCustLocality()");
		exit(90);
	      }
	      loclspace = 8;
	      loclcnt = 0;
	    } else if (loclcnt >= loclspace) {
	      loclspace += 8;
	      Localities = (LocalityRecord*) realloc(Localities,
						     sizeof(LocalityRecord) *
						     loclspace);
	      if (!Localities) {
		syslog(LOG_CRIT,"Realloc failed in InitCustLocality()");
		exit(90);	/* Realloc failed.. */
	      }
	    }

	    upper (domain);
	    if (debug) syslog(LOG_DEBUG," domain: readme `%s' (%x)",
			      classreadme ? classreadme : "(null)",
			      classreadme);

	    Localities[loclcnt].loc			= loc;
	    if ((Localities[loclcnt].domain = strdup(domain)) == NULL)
	      perror ("InitCustLocality malloc");
	    Localities[loclcnt].userid			= strdup(Userid);
	    Localities[loclcnt].haddr.s_addr		= 0L;
	    Localities[loclcnt].region			= RegionHead;
	    Localities[loclcnt].ClassReadme		= classreadme;
	    Localities[loclcnt].maxsendrate		= maxrate;
	    Localities[loclcnt].absmaxsendrate		= absmaxrate;
	    Localities[loclcnt].maxanonymous		= maxanon;
	    ++loclcnt;
	    continue;
	  }
	  if (strcasecmp(s,"newregion") == 0) {
	    RegionHead = NULL;
	    continue;
	  }
	  if (strcasecmp(s,"denyregion") ==0) {
	    char *s2 = NULL;
	    s = strtok(NULL,sep);
	    if (s)
	      s2 = strtok(NULL,"\n");
	    if (s) {
	      RegionStruct **rs = &RegionHead;
	      while (*rs) rs = &((*rs)->next);
	      *rs = (RegionStruct *)malloc(sizeof(RegionStruct));
	      (*rs)->deny_allow = 0; /* Deny */
	      (*rs)->pattern = strdup(s);
	      (*rs)->plen    = strlen(s);
	      (*rs)->comment = strdup(s2 ? s2 : "");
	      (*rs)->next = NULL;
	    }
	    if (debug) syslog(LOG_DEBUG,"denyregion \"%s\"",s);
	    continue;
	  }
	  if (strcasecmp(s,"allowregion") ==0) {
	    char *s2 = NULL;
	    s = strtok(NULL,sep);
	    if (s)
	      s2 = strtok(NULL,"\n");
	    if (s) {
	      RegionStruct **rs = &RegionHead;
	      while (*rs) rs = &((*rs)->next);
	      *rs = (RegionStruct *)malloc(sizeof(RegionStruct));
	      (*rs)->deny_allow = 1; /* Allow */
	      (*rs)->pattern = strdup(s);
	      (*rs)->plen    = strlen(s);
	      (*rs)->comment = strdup(s2 ? s2 : "");
	      (*rs)->next = NULL;
	    }
	    if (debug) syslog(LOG_DEBUG,"allowregion \"%s\"",s);
	    continue;
	  }
	  if (strncmp(s,"220",3)==0) {
	    s = strtok(NULL,"\n");
	    add_to_Banner200(&banner220,s ? s : "");
	    continue;
	  }
	  if (strncmp(s,"221",3)==0) {
	    s = strtok(NULL,"\n");
	    add_to_Banner200(&banner221,s ? s : "");
	    continue;
	  }
	  if (strncmp(s,"230",3)==0) {
	    s = strtok(NULL,"\n");
	    add_to_Banner200(&banner230,s ? s : "");
	    continue;
	  }
	  if (strcasecmp(s,"path")==0) {
	    s = strtok(NULL,"\n");
	    if (s)
	      PATH = strdup(s);
	    continue;
	  }
	  if (strcasecmp(s,"readme")==0) {
	    classreadme = strtok(NULL,sep);
	    if (classreadme)
	      classreadme = strdup(classreadme);
	    if (debug) syslog(LOG_DEBUG," parse: readme `%s' (%x)",
			      classreadme?classreadme:"(null)",
			      classreadme);
	    continue;
	  }
	  if (strcasecmp(s,"LIST")==0) {
	    /* LIST -command arguments.. */
	    s = strtok(NULL,"\n");
	    if (strlen(s) > 2)
	    strncpy(LISTcmdstr,s,sizeof(LISTcmdstr)-1);
	    LISTcmdstr[sizeof(LISTcmdstr)-1] = 0;
	    continue;
	  }
	  if (strcasecmp(s,"NLST")==0) {
	    /* NLST -command arguments.. */
	    s = strtok(NULL,"\n");
	    if (strlen(s) > 2)
	      strncpy(NLSTcmdstr,s,sizeof(NLSTcmdstr)-1);
	    NLSTcmdstr[sizeof(NLSTcmdstr)-1] = 0;
	    continue;
	  }
	  if (strcasecmp(s,"virtual")==0) {
	    char *s2, *s3;
	    /* virtual  ip.address.literal  chroot-dir chdir-dir */
	    s = strtok(NULL,sep);
	    s2 = strtok(NULL,sep);
	    s3 = strtok(NULL,sep);
	    if (!s || !s2 || !s3) continue;
	    if (!Virtuals) {
	      VirtualsCount = 0;
	      VirtualsSpace = 6;
	      Virtuals = (struct Virtuals*)malloc(VirtualsSpace *
						  (sizeof(*Virtuals)));
	    }
	    if (VirtualsSpace >= VirtualsCount) {
	      VirtualsSpace <<= 1;
	      Virtuals = (struct Virtuals*)realloc(Virtuals,
						   VirtualsSpace *
						   (sizeof(*Virtuals)));
	    }
	    Virtuals[VirtualsCount].haddr.s_addr = inet_addr(s);
	    Virtuals[VirtualsCount].chrootdir = strdup(s2);
	    Virtuals[VirtualsCount].chdirdir = strdup(s3);
	    ++VirtualsCount;
	    continue;
	  }
	}
	fclose(LocalityInfo);
	LocalityInfo = NULL;
	maxanonymous    = newmaxanonymous;
	maxanonymoussum = newmaxanonymous;

    out_out:
	{			/* Various cleanups, default values, .. */
	  char *pute;

	  if (PATH == NULL)
	    PATH = strdup("/bin:/usr/bin:/usr/ucb:/usr/local/bin");
	  pute = malloc(strlen(PATH)+8);
	  sprintf(pute,"PATH=%s",PATH);
	  putenv(pute);
	}
	if (Userid) free(Userid);
}


CUST_LOCALITY
AnalCustLocality(haddr,hostname,userid,forcedforeign)
const struct in_addr *haddr;
const char *hostname;
const char *userid;
const int forcedforeign;
{
	struct in_addr addr, oaddr;
	LocalityRecord *L = Localities;
	int cnt = loclcnt;

	addr.s_addr = ntohl(haddr->s_addr);
	oaddr = addr;
     
	maxsendrate = 102400;
	absmaxsendrate = 102400;
	Maxanonymous[CUST_LOCAL] = 200;

	/*if(debug)
	  syslog(LOG_DEBUG,"A.C.L.(addr=%08.8X, hname=%s, forceforeign=%d)",
	  addr, hostname, forcedforeign);*/
	if (!Localities) {
	  return CUST_LOCAL;
	}

	if (IN_CLASSA(addr.s_addr)) addr.s_addr &= IN_CLASSA_NET;
	if (IN_CLASSB(addr.s_addr)) addr.s_addr &= IN_CLASSB_NET;
	if (IN_CLASSC(addr.s_addr)) addr.s_addr &= IN_CLASSC_NET;

	--L;
	while (++L, cnt-- >0 && !forcedforeign) {
	  /* See if special userid orders something special.. */
	  if (L->userid[0] != '*' &&
	      strcasecmp(userid,L->userid) != 0)
	    continue;
	  /* Ok, either the userid was wild-card, or it matched. */
	  if (L->domain != NULL) {
		const char *s = hostname;
		int domlen = strlen(L->domain);

		if (strlen(hostname) < domlen)
		  continue;
		s += strlen(hostname)-domlen;
		if (strcasecmp(s, L->domain) == 0) {
		    maxsendrate    = L->maxsendrate;
		    absmaxsendrate = L->absmaxsendrate;
		    maxanonymous   = L->maxanonymous;
		    RegionHead	   = L->region;
		    ClassReadme    = L->ClassReadme;

		    Maxanonymous[L->loc] = L->maxanonymous;
		    /*if(debug)
		      syslog(LOG_DEBUG,
			     "A.C.L. match domain: `%s', maxrate=%d, absmaxrate=%d",
			     L->domain,maxsendrate,absmaxsendrate);*/
		    return (L->loc);
		}
	  }

	  /* Match "network" 1 -- failed IP-reversals */
	  if ((int)(L->haddr.s_addr) == 1 &&
	      (*hostname == '[' || inet_addr(hostname) != 0xFFFFFFFF)) {
	  	maxsendrate    = L->maxsendrate;
		absmaxsendrate = L->absmaxsendrate;
		maxanonymous   = L->maxanonymous;
		RegionHead     = L->region;
		ClassReadme    = L->ClassReadme;
		Maxanonymous[L->loc] = L->maxanonymous;
		/*if(debug)
		  syslog(LOG_DEBUG,
			 "A.C.L. match network: `%08.8X', maxrate=%d, absmaxrate=%d",
			 L->haddr.s_addr,maxsendrate,absmaxsendrate);*/
		return L->loc;
	  }
	  /* Match network -- or net 0 as a wild-card */
	  if ( L->haddr.s_addr == oaddr.s_addr || L->haddr.s_addr == addr.s_addr ||
	      ((L->haddr.s_addr == 0) && (L->domain == NULL))) {
	  	maxsendrate    = L->maxsendrate;
		absmaxsendrate = L->absmaxsendrate;
		maxanonymous   = L->maxanonymous;
		RegionHead     = L->region;
		ClassReadme    = L->ClassReadme;
		Maxanonymous[L->loc] = L->maxanonymous;
		/*if(debug)
		  syslog(LOG_DEBUG,
			 "A.C.L. match network: `%08.8X', maxrate=%d, absmaxrate=%d",
			 L->haddr.s_addr,maxsendrate,absmaxsendrate);*/
		return L->loc;
	  }
	}

     maxsendrate = 1024;
     absmaxsendrate = 1024;
     return CUST_FOREIGN;
}


int
VirtualMatch(my_addr,chrootstr,chdirstr)
const struct sockaddr_in *my_addr;
char *chrootstr, *chdirstr;
{
  int i;
  /* lreply(230,"(VirtualsCount=%d, my_addr=%s)",
     VirtualsCount, inet_ntoa(my_addr->sin_addr)); */
  if (VirtualsCount == 0) return 0;
  for (i = 0; i < VirtualsCount; ++i) {
    /* lreply(230,"( ... Virtuals[%d].haddr=%s)",i,inet_ntoa(Virtuals[i].haddr)); */
    if (Virtuals[i].haddr.s_addr == my_addr->sin_addr.s_addr) {
      strcpy(chrootstr,Virtuals[i].chrootdir);
      strcpy(chdirstr,Virtuals[i].chdirdir);
      return 1;
    }
  }
  return 0;
}



int
addr_match(hp,his_addr)
struct hostent *hp;
struct sockaddr_in *his_addr;
{
	/* XXX: This matches IP addresses only! */
	struct in_addr hisaddr;
	hisaddr = *(struct in_addr *)(&his_addr->sin_addr);
	if (!hp) return 0;	/* No hosts found.. */
	if (!hp->h_addr_list[0]) return 0;
	if (IN_CLASSA(hisaddr.s_addr)) hisaddr.s_addr &= IN_CLASSA_NET;
	if (IN_CLASSB(hisaddr.s_addr)) hisaddr.s_addr &= IN_CLASSB_NET;
	if (IN_CLASSC(hisaddr.s_addr)) hisaddr.s_addr &= IN_CLASSC_NET;
	do {
	  struct in_addr addra;
	  addra = *(struct in_addr *)(hp->h_addr_list[0]);
	  if (IN_CLASSA(addra.s_addr)) addra.s_addr &= IN_CLASSA_NET;
	  if (IN_CLASSB(addra.s_addr)) addra.s_addr &= IN_CLASSB_NET;
	  if (IN_CLASSC(addra.s_addr)) addra.s_addr &= IN_CLASSC_NET;
	  if (addra.s_addr == hisaddr.s_addr)
	    return 1;
	  hp->h_addr_list++;
	} while (hp->h_addr_list[0]);
	return 0;
}


void
PrintBanner200(code,ban)
const int code;
Banner200 *ban;
{
	while (ban && ban->line) {
	  lreply(code,"%s",ban->line);
	  ban = ban->next;
	}
}

char *
RegionDeny(fpath)
char *fpath;
{
	RegionStruct *rs = RegionHead;
	int pathlen = strlen(fpath);

	if (debug) syslog(LOG_DEBUG,"RegionDeny(\"%s\" (len=%d)) testing:",
			  fpath,pathlen);
	while(rs) {
	  if (rs->pattern)
	    if (debug) syslog(LOG_DEBUG," pattern: '%s', len=%d",
			      rs->pattern,rs->plen);
	    if (rs->plen <= pathlen &&
		strncmp(fpath,rs->pattern,rs->plen) == 0) {
	      if (debug) syslog(LOG_DEBUG,"RegionDeny(\"%s\") MATCH",fpath);
	      if (rs->deny_allow == 1 /* Allow */) return NULL;
	      if (rs->comment) return rs->comment;
	      return "";
	    }
	  rs = rs->next;
	}
	if (debug) syslog(LOG_DEBUG,"RegionDeny(\"%s\") fail",fpath);
	return NULL; /* Nothing */
}

#ifdef USE_STRDUP

char *strdup(s)
char *s;
{
	int len = 0;
	char *new;
	if (!s) return NULL;
	len = strlen(s);
	new = malloc(len+2);
	if (new) strcpy(new,s);
	return new;
}
#endif
