/* ================================================================

       CUSTomer LOCALITY.H	definitions

   Some extensions to BSD (tahoe/reno) FTP server.

   By  Matti Aarnio <mea@nic.funet.fi>  Jan-1991
   Copyright (c) FUNET 1991

   By all means, use and adapt to your usage, but don't claim you
   invented it ;-)

   ================================================================ */

#ifndef _CUSTLOCALITY_H
# define _CUSTLOCALITY_H

#ifndef	__
# ifdef __STDC__
#  define __(x) x
# else
#  define __(x) ()
# endif
#endif

#ifdef __STDC__
# include <netinet/in.h>
#endif

#define MAX_FTMP	15000	 /* should be enough.. */
			/* max number of traced customers.. */

typedef enum CUST_LOCALITY {
	CUST_LOCAL = 1,		/* 1  (usually)	Real local folks */
	CUST_CAMPUS,		/* 2	Campus area systems, or otherwise
				        dear buddies.  Ethernet or faster. */
	CUST_AREA,		/* 3	Extended campus, fast local
					connections. T1 to Ethernet */
	CUST_COUNTRY,		/* 4	Local to my own country		*/
	CUST_NORDUNET,		/* 5	Well, Nordic countries together run
					and own NORDUNET which connects our
					each country together.
					Map it to something which suits you. */
	CUST_EUROPE,		/* 6	Still larger network entity, for USA
					sites it could be called: CUST_USA */
	CUST_FOREIGN = 0	/* 0	Everything else */
} CUST_LOCALITY;
#define CUST_low  0
#define CUST_high 6


extern CUST_LOCALITY	AnalCustLocality __(( const struct in_addr *haddr,
					      const char *hostname,
					      const char *userid,
					      const int forcedforeign ));
extern void		InitCustLocality __(( const char *localityfilename ));
extern int		VirtualMatch __(( const struct sockaddr_in *my_addr,
					  char *chrootstr, char *chdirstr ));
extern void             RefreshCustLocality __((int forced));

typedef struct Banner200 {
	char *line;
	struct Banner200 *next;
} Banner200;

extern void		PrintBanner200 __(( const int code, Banner200 *ban));


#ifdef	CUST_MAIN
typedef struct {
  CUST_LOCALITY	loc;
  char *locname;
} LocalityEnumerationType;
static LocalityEnumerationType LocalityEnumerations[] = {
  { CUST_LOCAL,		"LOCAL"	},
  { CUST_CAMPUS,	"CAMPUS" },
  { CUST_AREA,		"AREA"	},
  { CUST_COUNTRY,	"COUNTRY" },
  { CUST_NORDUNET,	"NORDUNET" },
  { CUST_EUROPE,	"EUROPE" },
  { CUST_FOREIGN,	"FOREIGN" },
  { CUST_FOREIGN,	NULL }};

int	Maxsendrate[CUST_high+1];
int	Absmaxsendrate[CUST_high+1];
int	Maxanonymous[CUST_high+1];
char	*ClassName[CUST_high+1];
int	maxanonymous = 12;
int	maxanonymoussum = 12;
int	maxsendrate;
int	absmaxsendrate;
Banner200 *banner220 = NULL;
Banner200 *banner221 = NULL;
Banner200 *banner230 = NULL;

char	LISTcmdstr[30] = "ls -lgA %s";
char	NLSTcmdstr[30] = "ls %s";

#else
extern int	Maxsendrate[CUST_high+1];
extern int	Absmaxsendrate[CUST_high+1];
extern int	Maxanonymous[CUST_high+1];
extern char	*ClassName[CUST_high+1];
extern int	maxanonymous;
extern int	maxanonymoussum;
extern int	maxsendrate;
extern int	absmaxsendrate;
extern Banner200 *banner220;
extern Banner200 *banner221;
extern Banner200 *banner230;

extern char	LISTcmdstr[30];
extern char	NLSTcmdstr[30];
#endif

#endif /* _CUSTLOCALITY_H */
