/* FINDER -- regex system for scanning thru the /files/ALL_FILES -file */

/* By Matti Aarnio <mea@nic.funet.fi> 1990/1991 */

/* SHOULD be able to use defined data transfer port ...
   Maybe using some external program as well...   */

#include <stdio.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/stat.h>


extern int captivity; /* in ftpd.c main() */

#ifndef	__
#ifndef	__STDC__
#define	__(x)	()
#else
#define __(x)	x
#endif
#endif

extern FILE *ftpd_vpopenl __((char *path, char *type, char *argv0, ...));
extern       ftpd_pclose __((FILE *iop));
extern FILE *dataconn __((char *name, off_t size, char *mode, int pseudodev));
extern int   data, pdata;

void
finder(regexpstr,message)
     char *regexpstr, *message;
{
#define REPLYCODE 212 /* Positive final reply, informational */

	FILE *grep = NULL;
	FILE *dout = NULL;
	int rc;
	int count = 0;
	int lines = 0;
	char *s;
	char line[512];
	static int debugme = 0;
	struct stat stats;

	if (captivity) {
	  reply(530,"You haven't logged on properly.  No FIND available for you Sir/Madam.");
	  return;
	}
	if(regexpstr && strcmp(regexpstr,"DeBuG")==0) {
	  debugme = 1;
	  reply(REPLYCODE,"Debug of FIND turned on.");
	  return;
	}

	if (!regexpstr) {
	  reply(501,"Glob-pattern is missing! Give one!");
	  return;
	}


	findpathcmd(line,"locate");
if (debugme)
  lreply(212,"locate cmd: %s",line);
	grep = ftpd_vpopenl(line, "r", "locate",
			    "-d", "/files/LOCATE.DB", regexpstr, NULL);
	if (grep == NULL) {
	  lreply(530,"Couldn't open \"locate -d /files/LOCATE.DB '%s'\".",
		 regexpstr);
	  reply(530,"Report to  <problems>!");
	  return;
	}
	rc = stat("/files/LOCATE.DB",&stats);
	if (rc != 0) {
	  reply(530,"No /files/LOCATE.DB -file around !  Report to  <problems>!");
	  return;
	}
	if (message)
	  lreply(REPLYCODE,message);
	if ((stats.st_mtime + 90000 /* 25h */) < time(NULL))
	  lreply(REPLYCODE,
		 "Oops, database is now %4.1f hours old, well over 24h! Something wrong here!",
		 (double)(time(NULL) - stats.st_mtime)/3600.0);

	dout = dataconn("locate-pipe",BUFSIZ,"w",-1);
	if (dout) {
	  send_data(grep,dout,BUFSIZ,ftpd_pclose,0,"grep",-1);
	  fclose(dout);
	  data = -1;
	  pdata = -1;
	} else {
	  lreply(REPLYCODE,"Can't build data connection. You didn't use \"/search:\"-prefix");
	  lreply(REPLYCODE,"at normal data fetch command ?  Reverting to alternate method.");
	  lreply(REPLYCODE,"Matching case SENSITIVELY expr `%s'",regexpstr);
	  lreply(REPLYCODE,"Starting to parse /files/LOCATE.DB database:");
	  while( !feof(grep) && !ferror(grep) ) {
	    *line = 0;
	    if (!fgets( line,sizeof(line),grep )) break;
	    s = line + strlen(line) -1;
	    if (*s == '\n') *s = 0;
	    lreply(-REPLYCODE,"%s",line);
	    ++count;
	  }
	  ftpd_pclose(grep);
	  reply(REPLYCODE,"End of analysis.  %d matches found.",count);
	}
	
}
