#include "ftpd.c"

extern FILE *tmperr;

extern FILE *fdopen();

static FILE *
getdatasock(mode)	/* WARNING: return UIDNESS AFTER THIS CALL! */
	char *mode;
{
	int s, on = 1;
	int retrys = 90;
	FILE *datafile;

	if (data >= 0) {
		datafile = fdopen(data, mode);
		s = fileno(datafile);
		return datafile;
	}

	seteuid((uid_t)0);

retry:
	s = socket(AF_INET, SOCK_STREAM, 0);
	if (s < 0)
		return (NULL);

#if 0
	if (*mode == 'r') { /* RETR */
	  int size = 64*1024;
	  if (setsockopt(s, SOL_SOCKET, SO_SNDBUF,
			 (void*)&size, sizeof(size)))
	    ;
	  size = 2*1024;
	  if (setsockopt(s, SOL_SOCKET, SO_RCVBUF,
			 (void*)&size, sizeof(size)))
	    ;
	} else {	/* STOR */
	  int size = 64*1024;
	  if (setsockopt(s, SOL_SOCKET, SO_SNDBUF,
			 (void*)&size, sizeof(size)))
	    ;
	  size = 64*1024;
	  if (setsockopt(s, SOL_SOCKET, SO_RCVBUF,
			 (void*)&size, sizeof(size)))
	    ;
	}
#endif
	if (setsockopt(s, SOL_SOCKET, SO_REUSEADDR,
		       (char *) &on, sizeof (on)) < 0)
		goto realbad;
#ifdef SO_REUSEPORT
	if (setsockopt(s, SOL_SOCKET, SO_REUSEPORT,
		       (char *) &on, sizeof (on)) < 0)
		goto realbad;
#endif
	/* anchor socket to avoid multi-homing problems */
	data_source.sin_family = AF_INET;
	data_source.sin_port = htons(ntohs(ctrl_addr.sin_port) - 1);
	data_source.sin_addr = ctrl_addr.sin_addr;
	if (bind(s, (struct sockaddr *)&data_source,
		 sizeof (data_source)) < 0) {
	  if (errno != EADDRINUSE) return NULL;

	  close(s);
	  microsleep(100000); /* circa 100 ms */
	  if (--retrys > 0)
	    goto retry;

	  return NULL;	/* Giving up.. */
	}

	datafile = fdopen(s, mode);
	return datafile;

realbad:
	close(s);
	return (NULL);
}

FILE *
dataconn(name, size, mode, pseudodev)
	char *name;
	off64_t size;
	char *mode;
	int   pseudodev;
{
	char sizebuf[32];
	int retry = 0;
	FILE *datafile;
	int olderrno;
#ifdef IPTOS_LOWDELAY
	int tos;
#endif
	

	file_size = size;
	cumul_bytes += byte_count;
	byte_count = 0;
	if (size != (off64_t) -1)
	  (void) sprintf (sizebuf, " (%lld bytes)", size);
	else
	  (void) strcpy(sizebuf, "");
	if (pdata >= 0) {
	  struct sockaddr_in from;
	  int s, fromlen = sizeof(from);

	  s = accept(pdata, (struct sockaddr *)&from, &fromlen);
	  if (s < 0) {
	    if (pseudodev >= 0)
	      reply(425, "Can't open data connection; errno=%d", errno);
	    (void) close(pdata);
	    pdata = -1;
	    return(NULL);
	  }
	  (void) close(pdata);
	  pdata = s;
#ifdef IPTOS_LOWDELAY_nono
	  tos = IPTOS_LOWDELAY;
	  setsockopt(s, IPPROTO_IP, IP_TOS, (char *) &tos, sizeof(int));

#endif
	  reply(150, "Opening %s mode data connection for %s%s%s.",
		type == TYPE_A ? "ASCII" : "BINARY", name, sizebuf,
		pseudodev ? " <pseudodev-passive>" : "");
	  return(fdopen(pdata, mode));
	}
	if (data >= 0) {
	  reply(125, "Using existing data connection for %s%s%s.",
		name, sizebuf,
		pseudodev ? " <pseudodev>" : "");
	  usedefault = 1;
	  return (fdopen(data, mode));
	}
	if (usedefault)
	  data_dest = his_addr;
	usedefault = 1;

	datafile = getdatasock(mode);
	olderrno = errno;
	seteuid(user_uid);

	if (datafile == NULL) {
	  if (pseudodev >= 0) {

	    if (olderrno != EADDRINUSE) {
	      lreply(425,"* Error wasn't EADDRINUSE ??  errno=%d", olderrno);
	      lreply(425,"* Report this problem! -> <problems@%s>",hostname);
	    } else {
#ifndef SO_REUSEPORT
	      lreply(425,"* Here is a known bug in our operating system with usage of SO_REUSEADDR.");
	      lreply(425,"* This occurs during high network activity...(== far too often in here)");
	      lreply(425,"* Retrying your command will eventually be able to get past this error.");
	      lreply(425,"* If you do not know what this is about, just try again whatever you did,");
	      lreply(425,"* when you got this.  Don't bother us.");
	      lreply(425,"* Our system software vendor has been unable (so far) to fix this..");
#else
	      lreply(425,"* EADDRINUSE even though we use SO_REUSEPORT !!??");
	      lreply(425,"* PLEASE REPORT THIS PROBLEM!  -> <problems@%s>",
		     hostname);
	      syslog(LOG_DEBUG,"SO_REUSEPORT failure!");
#endif
	    }
	    reply(425, "Can't create data socket (%s,%d): %s. mode=%s, please retry",
		  inet_ntoa(data_source.sin_addr),
		  ntohs(data_source.sin_port),
		  olderrno < sys_nerr ? sys_errlist[olderrno] : 
					"unknown error",
		  mode);
	  }
	  return (NULL);
	}

	data = fileno(datafile);
if (debug)  sleep(20);
	while (connect(data, (struct sockaddr *)&data_dest,
		       sizeof (data_dest)) < 0) {
	  if (errno == EADDRINUSE && retry < swaitmax) {
	    microsleep(((unsigned) swaitint) * 1000000L);
	    retry += swaitint;
	    continue;
	  }
	  if (pseudodev >= 0)
	    perror_reply(425, "Can't build data connection");
	  (void) fclose(datafile);
	  data = -1;
	  return (NULL);
	}
	reply(150, "Opening %s mode data connection for %s%s%s.",
	      type == TYPE_A ? "ASCII" : "BINARY", name, sizebuf,
	      pseudodev ? " <pseudodev>" : "");
	return (datafile);
}

/* ================================================================ */
/*		Flow throttles					    */
/* ================================================================ */
static time_t time0, time1, timen;
static off64_t start0 = 0, startrate = 0;
static off64_t startcnt = 0;
static off64_t throttle_rate;
static int throttle_cnt = 0;
static int getsetcalls = 0;
static int tail_update;
static int block_size;

#define THRCOUNT 32
#define MAXTHRBYTES 65536 /* At least this-often re-check throttle.. */

#define THROTTLE	throttle();
static void
throttle()
{
	int __dbcnt, __dt, __myBps, __myclassBps, __myClSndrs;
	int __sleepcnt;

	if (!guest) return; /* Not a quest, nothing to do! */

	if (maxsendrate != 0 /* not unlimited */) {
	  __sleepcnt = 0;
	  if (throttle_cnt < 1) {
	    /* Recalc throttle params */
	    __dbcnt = (byte_count-startrate);
	    __dt = (time(&timen)-time1);
	    __myBps = __dt ? __dbcnt/__dt : __dbcnt;
	    if (timen == time0) timen++;
	    if (__myBps < 0) __myBps = -__myBps;
	    ++getsetcalls;
	    getsetftmpBps(1,cumul_bytes+byte_count,timen,
			  (byte_count-start0)/(timen-time0),
			  __myBps, throttle_rate,&__myclassBps,&__myClSndrs);
	    ++__myClSndrs; 	/* Always add one -- healthy suspicion.. */
	    throttle_rate = (1+((Maxsendrate[custlocality]*
				 Maxanonymous[custlocality])/__myClSndrs))/2;
	    if (throttle_rate > Absmaxsendrate[custlocality])
	      throttle_rate = Absmaxsendrate[custlocality];
	    throttle_cnt = THRCOUNT;
	    startrate = byte_count;
	    startcnt  = byte_count;
	    if (__dt > throttle_cnt+2) throttle_cnt = 2;
	    time1 = timen;

	    if (debug)
	      syslog(LOG_DEBUG, "getsetftmpBps(callcnt=%d): mybps: %d, MyClassBps: %d, MyClassSenders: %d",
		     getsetcalls, __myBps, __myclassBps, __myClSndrs);
	  }
	  while ((byte_count - startcnt) >= throttle_rate &&
		 0 <= throttle_cnt ) {
	    startcnt += throttle_rate;
	    ++__sleepcnt;
	    --throttle_cnt;
	  }
	  if (__sleepcnt)
	    microsleep(__sleepcnt * 500000 /* 0.5 s */);
	} else {		/* unlimited rates users */
	  /* These are for BOOK-KEEPING ONLY, NO THROTTLING! */
	  if (throttle_cnt < 1) {
	    /* Recalc throttle params */
	    __dbcnt = (byte_count-startrate);
	    __dt = (time(&timen)-time1);
	    __myBps = __dt ? __dbcnt/__dt : __dbcnt;
	    if (timen == time0) timen++;
	    if (__myBps < 0) __myBps = -__myBps;
	    ++getsetcalls;
	    getsetftmpBps(1,cumul_bytes+byte_count,timen,
			  (byte_count-start0)/(timen-time0),
			  __myBps, throttle_rate,
			  &__myclassBps,&__myClSndrs);
	    throttle_rate = MAXTHRBYTES;
	    throttle_cnt = 1;	/* Book keeping ! */
	    startrate = byte_count;
	    startcnt  = byte_count;
	    time1 = timen;

	    if (debug)
	      syslog(LOG_INFO, "getsetftmpBps(callcnt=%d): mybps: %d, MyClassBps: %d, MyClassSenders: %d",
		     getsetcalls, __myBps, __myclassBps, __myClSndrs);
	  }
	  if (byte_count - startcnt >= throttle_rate)
	    --throttle_cnt;
	}
}

#define THROTTLEOFF \
	if (guest)	\
	  getsetftmpBps(0,cumul_bytes+byte_count,0,0,0,0,NULL,NULL)



/*
 * Transfer the contents of "instr" to
 * "outstr" peer using the appropriate
 * encapsulation of the data subject
 * to Mode, Structure, and Type.
 *
 * NB: Form isn't handled.
 *
 */
void
send_data(instr, outstr, blksize, closefunc, fancy, name, forced_eof)
	FILE *instr, *outstr;
	off64_t blksize;
	int (*closefunc)(FILE*);
	int fancy;
	char *name;
	long forced_eof;
{
	register int c, cnt;
	register char *buf;
	int netfd, filefd;
	int rc;
	int fancysize = 0;
	void (*oldpipe)() = NULL;
	int this_count = 0;

	start0    = byte_count;
	startrate = byte_count;
	startcnt  = byte_count;
	throttle_rate = maxsendrate ? maxsendrate : blksize;
	throttle_cnt = 0;
	block_size = blksize;
	time1 = time(&time0);

	SIGNAL_HANDLESAVE(SIGPIPE, SIG_IGN, oldpipe);

	transflag++;
	if (setjmp(urgcatch)) {
		transflag = 0;
		if (fancy <= 0)
		  (*closefunc)(instr);
		THROTTLEOFF;	/* If  ABOR,  turn it off.. */
		SIGNAL_HANDLE(SIGPIPE,oldpipe);
		return;
	}

	SIGNAL_HANDLESAVE(SIGPIPE, SIG_IGN, oldpipe);

	if (fancy>0) goto FancyTransfer;

	switch (type) {

	case TYPE_A:
#ifdef SETPROCTITLE
		tail_update = byte_count+8000;
		setproctitletail(" [RETR %d/%d]",byte_count,cumul_bytes+byte_count);
#endif
		while ((c = getc(instr)) != EOF) {
			byte_count++;
			this_count++;
			if (forced_eof > 0 && this_count > forced_eof)
			  break;
			if (c == '\n') {
				if (ferror(outstr)) {
					THROTTLEOFF;
					goto data_err;
				}
				(void) putc('\r', outstr);
				if (ferror(outstr)) {
					THROTTLEOFF;
					goto data_err;
				}
				byte_count++;
			}
			(void) putc(c, outstr);
			THROTTLE
			if (byte_count > tail_update) {
#ifdef SETPROCTITLE
			  setproctitletail(" [RETR %d/%d:%d]",
					   byte_count,cumul_bytes+byte_count,
					   getsetcalls);
#endif
			  tail_update = byte_count + 8000;
			  alarm(timeout); /* Rearm the timer */
			}
		}
		THROTTLEOFF;
#ifdef SETPROCTITLE
		setproctitletail(" (RETR %d/%d)",
				 byte_count,cumul_bytes+byte_count);
#endif
		fflush(outstr);
		transflag = 0;
		if (ferror(instr))
			goto file_err;
		if (ferror(outstr))
			goto data_err;
		SIGNAL_HANDLE(SIGPIPE,oldpipe);
/*		reply(226, "Transfer complete.");	*/
		rc = (*closefunc)(instr);
		if( rc == 0 ) {
		  lreplys(226, tmperr, "Previous subprocess reported following to stderr:","");
		  reply(226, "Transfer complete.");
		} else {
		  lreplys(426, tmperr, "Previous subprocess reported following to stderr:","");
		  reply(426, "Sub process return code: 0x%X",rc);
		}
		return;

	case TYPE_I:
	case TYPE_L:
		if ((buf = malloc(block_size)) == NULL) {
			transflag = 0;
			SIGNAL_HANDLE(SIGPIPE,oldpipe);
			perror_reply(451, "Local resource failure:malloc");
			return;
		}
		netfd = fileno(outstr);
		filefd = fileno(instr);
#ifdef SETPROCTITLE
		tail_update = byte_count+8000;
		setproctitletail(" [RETR %d/%d]",byte_count,cumul_bytes+byte_count);
#endif
		while ((cnt = fread(buf, 1, block_size, instr)) > 0) {
			byte_count += cnt;
			this_count += cnt;
			/* Will it be over the  forced_eof  limit ? */
			if (forced_eof > 0 && this_count > forced_eof)
			  cnt += forced_eof - this_count;
			/* Anything to be written ? */
			if (forced_eof > 0 && cnt <= 0) {
			  cnt = 0; /* Simulate EOF */
			  break;
			}
			/* write -- and quit if fail.. */
			if (write(netfd, buf, cnt) != cnt)
			  break;
			THROTTLE
			block_size = throttle_rate;
			if (block_size > blksize)
			  block_size = blksize;
			if (byte_count > tail_update) {
#ifdef SETPROCTITLE
			  setproctitletail(" [RETR %d/%d:%d]",
					   byte_count,cumul_bytes+byte_count,
					   getsetcalls);
#endif
			  tail_update = byte_count + 8000;
			  alarm(timeout); /* Rearm the timer */
			}
		}
		THROTTLEOFF;
#ifdef SETPROCTITLE
		setproctitletail(" (RETR %d/%d)",
				 byte_count,cumul_bytes+byte_count);
#endif
		transflag = 0;
		(void)free(buf);
		if (cnt != 0) {
			if (cnt < 0)
				goto file_err;
			goto data_err;
		}
		SIGNAL_HANDLE(SIGPIPE,oldpipe);
/*		reply(226, "Transfer complete.");	*/
		rc = (*closefunc)(instr);
		if( rc == 0 ) {
		  lreplys(426, tmperr, "Previous subprocess reported following error to stderr:","");
		  reply(226, "Transfer complete.");
		} else {
		  lreplys(426, tmperr, "Previous subprocess reported following error to stderr:","");
		  reply(426, "Sub process return code: 0x%X",rc);
		}
		return;
	default:
		transflag = 0;
		SIGNAL_HANDLE(SIGPIPE,oldpipe);
		reply(550, "Unimplemented TYPE %d in send_data", type);
		return;
	}

data_err:
	transflag = 0;
	SIGNAL_HANDLE(SIGPIPE,oldpipe);
	lreplys(426, tmperr, "subproc stderr:","");
	perror_reply(426, "Data connection");
	return;

file_err:
	transflag = 0;
	SIGNAL_HANDLE(SIGPIPE,oldpipe);
	lreplys(551, tmperr, "subproc stderr:","");
	perror_reply(551, "Error on input file");
	return;

FancyTransfer:

	if (strcmp(name,"/dev/null")==0) fancysize = 0;
	else if (strcmp(name,"/dev/100MB")==0)  fancysize = 104857600;
	else if (strcmp(name,"/dev/30MB")==0)  fancysize = 3*10485760;
	else if (strcmp(name,"/dev/10MB")==0)  fancysize = 10485760;
	else if (strcmp(name,"/dev/4MB")==0)  fancysize = 4194304;
	else fancysize = 1048576; /* 1 MB */

#define FANCYBLK (64*1024)

	fancy = fancysize;
	if ((buf = malloc(FANCYBLK)) == NULL) {
	  transflag = 0;
	  SIGNAL_HANDLE(SIGPIPE,oldpipe);
	  perror_reply(451, "Local resource failure:malloc");
	  return;
	}
	memset(buf, 0, FANCYBLK);

	netfd = fileno(outstr);
#ifdef SETPROCTITLE
		tail_update = byte_count+8000;
		setproctitletail(" [RETR %d/%d]",byte_count,cumul_bytes+byte_count);
#endif
	while( fancysize > 0 ) {
	  c = fancysize > FANCYBLK ? FANCYBLK : fancysize;
	  cnt = write(netfd, buf, c);
	  if (cnt < 0) goto data_err;
	  byte_count += cnt;
	  fancysize -= cnt;
	  THROTTLE
#ifdef SETPROCTITLE
	    if (byte_count > tail_update) {
	      setproctitletail(" [RETR %d/%d]",
			       byte_count,cumul_bytes+byte_count);
	      tail_update = byte_count + 8000;
	    }
#endif
	}
	THROTTLEOFF;
#ifdef SETPROCTITLE
	setproctitletail(" (RETR %d/%d)",
			 byte_count,cumul_bytes+byte_count);
#endif

	transflag = 0;
	(void)free(buf);
	SIGNAL_HANDLE(SIGPIPE,oldpipe);
	reply(226, "Transfer complete. %d bytes send.",fancy);
}

/*
 * Transfer data from peer to
 * "outstr" using the appropriate
 * encapulation of the data subject
 * to Mode, Structure, and Type.
 *
 * N.B.: Form isn't handled.
 */
int
receive_data(instr, outstr, nullsink)
	FILE *instr, *outstr;
	int nullsink;
{
	register int c;
	int cnt;
	char buf[BUFSIZ];

	transflag++;
	if (setjmp(urgcatch)) {
		transflag = 0;
		return (-1);
	}
	switch (type) {

	case TYPE_I:
	case TYPE_L:
		tail_update = byte_count+8000;
		alarm(timeout);
		while ((cnt = fread(buf, 1, sizeof buf, instr)) > 0) {
			if (!nullsink)
			  if (write(fileno(outstr), buf, cnt) != cnt)
			    goto file_err;
			byte_count += cnt;
			if (byte_count > tail_update) {
			  tail_update = byte_count + 8000;
			  alarm(timeout);
#ifdef SETPROCTITLE
			  setproctitletail(" (STOR %d/%d)",
					   byte_count,cumul_bytes+byte_count);
#endif
			}
		}
		if (cnt < 0)
			goto data_err;
		transflag = 0;
		return (0);

	case TYPE_E:
		reply(553, "TYPE E not implemented.");
		transflag = 0;
		return (-1);

	case TYPE_A:
		tail_update = byte_count+8000;
		alarm(timeout);
		while ((c = getc(instr)) != EOF) {
			byte_count++;
			while (c == '\r') {
				if (!nullsink && ferror(outstr))
					goto data_err;
				if ((c = getc(instr)) != '\n') {
					if (!nullsink)
					  (void) putc ('\r', outstr);
					if (c == '\0' || c == EOF)
						goto contin2;
				}
			}
			if (!nullsink)
				(void) putc(c, outstr);
		contin2:;
			if (byte_count > tail_update) {
			  tail_update = byte_count + 8000;
			  alarm(timeout);
#ifdef SETPROCTITLE
			  setproctitletail(" (STOR %d/%d)",
					   byte_count,cumul_bytes+byte_count);
#endif
			}
		}
		if (!nullsink)
		  fflush(outstr);
		if (!nullsink && ferror(instr))
			goto data_err;
		if (!nullsink && ferror(outstr))
			goto file_err;
		transflag = 0;
		return (0);
	default:
		reply(550, "Unimplemented TYPE %d in receive_data", type);
		transflag = 0;
		return (-1);
	}

data_err:
	transflag = 0;
	perror_reply(426, "Data Connection");
	return (-1);

file_err:
	transflag = 0;
	perror_reply(452, "Error writing file");
	return (-1);
}
