#define  MAIN 1
#include "ftpd.c"
#include "custlocality.h"

char envPWD [MAXPATHLEN+7];
char envFTPD[MAXPATHLEN+7];
char VirtualChdir[MAXPATHLEN+7] = "";
FILE *tmperr;
char TZ[20]= "UTC";

extern struct tm *localtime();
extern void setrfc931auth();
extern int  AllowAccess;
extern int  getopt(), optind, opterr;
extern char *optarg;

static int do_ident_query = 0;

#define CHILDIGNORE

void reaper()
{
	int waitval;
#ifndef CHILDIGNORE
	SIGNAL_HANDLE(SIGCHLD, reaper);
#endif
#ifdef USE_WAITPID
	while (waitpid((pid_t)-1,&waitval,WNOHANG) > 0) ;
#else
#ifdef WNOHANG
	while (wait3(&waitval,WNOHANG,NULL) > 0) ;
#else
	wait(&waitval);
#endif
#endif
}

void timedreaper()
{
	int waitval;
#ifndef CHILDIGNORE
	SIGNAL_HANDLE(SIGCHLD, reaper);
#endif
#ifdef USE_WAITPID
	while (waitpid((pid_t)-1,&waitval,WNOHANG) > 0) ;
#else
#ifdef WNOHANG
	while (wait3(&waitval,WNOHANG,NULL) > 0) ;
#endif
#endif
}

void sighupper()
{
	SIGNAL_HANDLE(SIGHUP,sighupper);
	RefreshCustLocality(1);
}


int
main(argc, argv, envp)
	int argc;
	char *argv[];
	char **envp;
{
	int addrlen, on = 1;
	char **e;
	int c;
	time_t t;
	struct tm *tm;
	int daemonmode = 0;
	int no_detach  = 0;
	short ftpd_port = 21;
	struct passwd *pw;

	struct hostent *hostent; /* [mea@nic.funet.fi] Dig up my real name - always! */

#ifdef SecureWare
	setluid(1);		/* make sure there is a valid luid */
	set_auth_parameters(argc,argv);
	setreuid(0, 0);
#endif

	addrlen = sizeof (his_addr);
	if (getpeername(0, (struct sockaddr *)&his_addr, &addrlen) < 0) {
	  /* Not daemon.. */
	} else {
	  dup2(0,1);	/* Bind stdout and stderr also to the FD 0 .. */
	  dup2(0,2);
	}

	strcpy(envFTPD,"FTPD_LS=-Z");	/* Special features from our special ls, and gtar.. */
	putenv(envFTPD);
	strcpy(envPWD,"PWD=/");
	putenv(envPWD);

	openlog("ftpd", LOG_NDELAY|LOG_PID, FTP_LOG_FACILITY);

	debug = 0;
#ifdef SETPROCTITLE
	/*
	 *  Save start and extent of argv for setproctitle.
	 */
	Argv = argv;
	e = argv;
	while (*e)
		e++;
	LastArgv = e[-1] +strlen(e[-1]); /* Spare room.. */
#endif /* SETPROCTITLE */

	while ((c = getopt(argc,argv,"vdlA:INp:t:T:u:XDn")) != -1) {
	    switch (c) {

		case 'v':
			debug = 1;
			break;

		case 'd':
			debug = 1;
			putenv("FTPD_DEBUG=on");
			break;

		case 'l':
			logging = 1;
			break;

		case 'A':
			maxanonymous = atoi(optarg);
			if (maxanonymous < 2)
				maxanonymous = 2;
			break;

		case 'N':
			no_lreply = 1;
			break;

		case 'p':
			ftpd_port = atoi(optarg);
			if (ftpd_port < 21)
				ftpd_port = 21;
			break;

		case 't':
			timeout = atoi(optarg);
			if (maxtimeout < timeout)
				maxtimeout = timeout;
			break;

		case 'T':
			maxtimeout = atoi(optarg);
			if (timeout > maxtimeout)
				timeout = maxtimeout;
			break;
		case 'u':
		    {
		        char *endptr;
			int val = strtol(optarg,&endptr,8);

			if (val == 0 && endptr == optarg)
				fprintf(stderr, "ftpd: Bad value for -u\n");
			else
				defumask = val;
			break;
		    }

		case 'X': break;
		case 'I':
			do_ident_query = 1;
			break;

		case 'D':
			daemonmode = 1;
			break;
		case 'n':
			no_detach = 1;
			break;
			
		default:
			fprintf(stderr, "ftpd: Unknown flag -%c ignored.\n",c);
			break;
		}
	}

	InitCustLocality(_PATH_FTPD_CONFIG);

	if (daemonmode) {
	  int listensocket, acceptsocket;
	  int on = 1;
	  int i;
	  FILE *pidfile = NULL;

	  if (!debug && !no_detach) {
	    for (i=getdtablesize()-1;i >= 0; --i)
	      close(i);
	    if (fork() == 0) {
	      /* We are the child.. */
	    } else {
	      /* We are the parent */
	      exit(0);
	    }
	  }

	  listensocket = socket(AF_INET,SOCK_STREAM,0);
	  if (setsockopt(listensocket, SOL_SOCKET, SO_REUSEADDR, (void*)&on, sizeof(on)) < 0) {
	    /* XX: error processing */
	  }


	  ctrl_addr.sin_family      = AF_INET;
	  ctrl_addr.sin_addr.s_addr = htonl(INADDR_ANY);
	  ctrl_addr.sin_port	    = htons(ftpd_port);

	  while (bind(listensocket, (void*)&ctrl_addr, sizeof(ctrl_addr)) < 0) {
	    /* XX: error processing */
	    if (errno == EADDRINUSE) {
	      /* Ah well, wait, and redo.. */
	      sleep(5);
	    } else
	      exit(99);
	  }

	  if (!pidfile && ftpd_port == 21) {
	    pidfile = fopen("/etc/ftpd.pid","w");
	    if (pidfile) {
	      chmod("/etc/ftpd.pid",0644);
	      fprintf(pidfile,"%d\n",(int)getpid());
	      fclose(pidfile);
	    }
	  }

	  if (listen(listensocket, 1000) < 0) {
	    /* XX: error processing */
	  }
#ifdef CHILDIGNORE
#ifdef	SIGCHLD
	  SIGNAL_IGNORE(SIGCHLD);
#else
	  SIGNAL_IGNORE(SIGCLD);
#endif
#else
	  SIGNAL_HANDLE(SIGCHLD, reaper);
#endif
	  SIGNAL_HANDLE(SIGHUP,  sighupper);
	  SIGNAL_HANDLE(SIGTERM, SIG_DFL);
	  for (;;) {
	    int childpid;
	    static int reapercnt = 0;

	    addrlen = sizeof(his_addr);
	    acceptsocket = accept(listensocket, (void*)&his_addr, &addrlen);
	    if (acceptsocket < 0) {
	      if (errno == EBADF) exit(1); /* !!?? BAD !!?? */
	      /* XX: error processing.. */
	      continue; /* Hrmpf.. */
	    }
	    /* Refresh the CustLocality data -- if there is need..
	       this WILL leak memory! */
	    RefreshCustLocality(0);
	    childpid = 0;

	    if ((childpid = fork()) < 0) {
	      close(acceptsocket);
	      sleep(5);
	      continue;
	    }
	    if (childpid == 0) {
	      close(listensocket);
	      if (acceptsocket != 0)
		dup2(acceptsocket,0);
	      if (acceptsocket != 1)
		dup2(acceptsocket,1);
	      if (acceptsocket > 1)
		close(acceptsocket);
	      break; /* From the for(;;) ... */
	    }
	    close(acceptsocket);
	    if (++reapercnt > 20) {
	      timedreaper();
	      reapercnt = 0;
	    }
	  }
	} else { /* Not daemon -- started from inetd */
	  /* Hmm.. Something ?? */
	}


	addrlen = sizeof (his_addr);
	if (getpeername(0, (struct sockaddr *)&his_addr, &addrlen) < 0) {
	  syslog(LOG_ERR, "getpeername (%s): %m",argv[0]);
	  exit(1);
	}
	addrlen = sizeof (ctrl_addr);
	if (getsockname(0, (struct sockaddr *)&ctrl_addr, &addrlen) < 0) {
	  syslog(LOG_ERR, "getsockname (%s): %m",argv[0]);
	  exit(1);
	}

	setrfc931auth(0, &ctrl_addr, &his_addr);


	data_source.sin_port = htons(ntohs(ctrl_addr.sin_port) - 1);
	hostent = gethostbyaddr((void*)&his_addr.sin_addr,4,his_addr.sin_family);
	if( hostent == NULL ) {
	    extern int h_errno;
	    char hebuf[30];
	    switch(h_errno) {
	      case HOST_NOT_FOUND:
	          sprintf(hebuf," -- No registered data");
		  break;
	      case TRY_AGAIN:
		  sprintf(hebuf," -- Query timeout (retrying may help)");
		  break;
	      case NO_RECOVERY:
		  sprintf(hebuf," -- No Recovery ??");
		  break;
	      case NO_ADDRESS:
		  sprintf(hebuf," -- No address");
		  break;
	      default:
		  sprintf(hebuf," -- unexpected error, h_errno=%d",h_errno);
		  break;
	    }
	    sprintf(remotehostname,"[%s]%s",inet_ntoa(his_addr.sin_addr),hebuf);
	} else
	  strcpy(remotehostname,hostent->h_name );
	remotenameOK = (hostent != NULL);
	hostent = gethostbyaddr((void*)&ctrl_addr.sin_addr,4,ctrl_addr.sin_family);
	if (hostent)
	  strcpy( hostname,hostent->h_name );
	else
	  *hostname = 0;


	/* (void) freopen("/dev/null", "w", stderr); */
	SIGNAL_HANDLE(SIGPIPE, lostconn);
#ifdef	SIGCHLD
	SIGNAL_IGNORE(SIGCHLD);
#else  /* must be USG... */
	SIGNAL_HANDLE(SIGCLD);
#endif
#ifdef	SIGURG
	SIGNAL_HANDLE(SIGURG, myoob);
#else  /* must be USG... */
	SIGNAL_HANDLE(SIGPOLL, myoob);
#endif
	SIGNAL_HANDLE(SIGFPE, floaterr);

	/* handle urgent data inline */
	/* Sequent defines this, but it doesn't work */
#ifdef SO_OOBINLINE
	if (setsockopt(0, SOL_SOCKET, SO_OOBINLINE, (char *)&on, sizeof(on)) < 0)
		syslog(LOG_ERR, "setsockopt: %m");
#endif
#ifdef	F_SETOWN
	if (fcntl(fileno(stdin), F_SETOWN, getpid()) == -1)
		syslog(LOG_ERR, "fcntl F_SETOWN: %m");
#endif
	dolog(&his_addr);
	/*
	 * Set up default state
	 */
	data = -1;
	type = TYPE_A;
	form = FORM_N;
	stru = STRU_F;
	mode = MODE_S;
	tmpline[0] = '\0';

	tmperr = tmpfile();

	if (*hostname == 0) {	/* Do it in the old-fashioned way
				   if interface IP-reversal fails.. */
	  (void) gethostname(hostname, sizeof (hostname));
	  hostent = gethostbyname(hostname);
	  if( hostent == NULL && h_errno == TRY_AGAIN )
	    hostent = gethostbyname(hostname);
	  /* Well, we try again.. once */
	  if( hostent != NULL )
	    /* Got anything ?  Its our domain name! */
	    strcpy( hostname,hostent->h_name );
	}
#if 0
if (strncmp(remotehostname,"mea.",4)==0) { lreply(220,"mea: mypid=%d - will sleep 30 sec now",getpid());sleep(30);}
#endif

	/* We do ftmp logging and find out how many
	   anonymouses we have simultaneously		 */
	custlocality = AnalCustLocality(&his_addr.sin_addr, remotehostname,
					"*",0);
	ftpcnt = logftmp(gttyline,"CONNECT-phase",remotehost,custlocality,
			 0,Counts);

	check_closure("/");
	pw = getpwnam("ftp"); /* The magic init of anon-ftp.. */
	if (pw != NULL)
	  check_closure(pw->pw_dir);


	{
	  int save_no = no_lreply;
	  no_lreply = 0;
	  lreply(220, "Hello %s at %s,",auth_username, remotehostname);
	  /*
	     if (save_no)
	     lreply(220,"This is responce-shrinkage mode, a lot of usefull information is now stripped!");
	   */
	  no_lreply = save_no;
	}
	{
	  char *r = remotehostname;
	  while (*r  != 0) {
	    if (*r <= ' ' || *r > 126) *r = '_';
	    ++r;
	  }
	}
	if (*remotehostname == '[') {
	  lreply(220, "");
	  lreply(220, "We are unable to identify your system.  Please read `README.IP-REVERSAL'-");
	  lreply(220, "file for possible explanation of the problem.  Get it before logging in!");
	  lreply(220, "IP-ADDRESS NON REVERSAL IS (usually) A PROBLEM AT *YOUR END*, CONTACT");
	  lreply(220, "YOUR NETWORK ADMINISTRATION FOR CORRECTION OF THE PROBLEM!");
	  lreply(220, "We can assist you, if you send a VERBATIM log of the ftp-session to");
	  lreply(220, "address: `problems@%s'",hostname);
	}
/*	lreply(220, "");
	lreply(220, "Welcome to the FUNET archive.  Please login as `anonymous' with your");
	lreply(220, "E-mail address as the password to access the archive.");
	lreply(220, "See README file for more information about this archive.");
*/
	PrintBanner200(220,banner220);
	lreply(220, "");
	lreply(220, "%s FTP server (%s) ready.", hostname, version);
	lreply(220,
	       "There are %d (max %d) archive users in your class at the moment.",
	       Counts[custlocality],Maxanonymous[custlocality]);
	lreply(220, "Assuming 'login anonymous', other userids do vary.)");
	if (Counts[custlocality] > Maxanonymous[custlocality]) {
	  lreply(220,"");
	  lreply(220,"Of those, %d are attempting to come in, but are over the logon quota,",
		 Counts[custlocality] - Maxanonymous[custlocality]);
	  lreply(220,"and will be refused now.  If You logon as \"anonymous\", you will be");
	  lreply(220,"among them, unfortunately.  Try again later.");
	  lreply(220,"");
	}

	time (&t);
	tm = localtime(&t);
	strftime(TZ,sizeof(TZ)-1,"%Z",tm);
	lreply(220,"Local time is %24.24s %s",ctime(&t),TZ);
	lreply(220,"");

	reply(220,"You can do \"get README\" even without logging in!");
	strcpy(workpath,"/");	/* Initialize workpath to be the root.. */
	usecanonicpath = 1;	/* Resolve .././foo//../ -paths into their basic form as a default */

	setjmp(errcatch);

	for (;;)
		(void) yyparse();
	/* NOTREACHED */
}

void lostconn()
{
	if (debug)
		syslog(LOG_INFO, "lost connection");
	
	dologout(-1);
}

void floaterr()
{
	syslog(LOG_ALERT, "SIGFPE hit me..");
	end_login("SIGFPE");
	exit(0);
}

void
setrfc931auth(sd, ctrl_addr, his_addr)
unsigned int sd;
struct sockaddr_in *ctrl_addr, *his_addr;
{
	char *cp = NULL;
	strncpy(auth_username, "UNKNOWN", MAXHOSTNAMELEN);

	if (do_ident_query)
	  cp = auth_tcpuser3( &ctrl_addr->sin_addr, &his_addr->sin_addr,
			      ntohs(ctrl_addr->sin_port),
			      ntohs(his_addr->sin_port),
			      AUTH_TIMEOUT );
	if ( cp != NULL )
	  strncpy(auth_username, cp, MAXHOSTNAMELEN);
}
