#include "ftpd.c"
#include "extensions.h" /* WUARCHIVE extensions */

extern FILE *tmperr;

#if	defined(SVR4) || defined(SYSV) || defined(USG) || defined(USE_GETCWD)
# define getwd(str) getcwd(str,sizeof(str))
extern char *getcwd();
#else
extern char *getwd();
#endif
extern int errno;

int
CheckFancyPermit(path,code)
     char *path;
     char code;
{
	char cwd[MAXPATHLEN];
	struct stat64 stats;
	int err1, err2;
	int i = 30;

	/*if(!guest) return 0;*/

	if( getwd(cwd) == NULL) {
	  lreply(550," getcwd() failed by returning a NULL in CheckFancyPermit(). Report bug to maintainers.  errno=%d",errno);
	  syslog(FTP_LOG_PRIORITY," getwd() failed by returning a NULL in CheckFancyPermit().");
	  return 1;
	  }
	chdir(path);	/* This succeeds for sure - or is called illegally */
#define FILE_PRESENT(x) (0 == lstat64( (x),&stats) )
	if( code == 'Z' ) { /* [mea] .No.tar.Z vs .Yes.tar.Z */
		err1= FILE_PRESENT(".No.tar.Z");
		err2= FILE_PRESENT(".Yes.tar.Z");
		while( !(err1 || err2) && i-- > 0 ) {
			chdir("..");
			if((err1= FILE_PRESENT(".No.tar.Z"))) break;
			if((err2= FILE_PRESENT(".Yes.tar.Z"))) break;
		}
	} else {
		err1= FILE_PRESENT(".No.tar");
		err2= FILE_PRESENT(".Yes.tar");
		while( !(err1 || err2) && i-- > 0 ) {
			chdir("..");
			if((err1= FILE_PRESENT(".No.tar"))) break;
			if((err2= FILE_PRESENT(".Yes.tar"))) break;
		}
	}
#undef FILE_PRESENT
	chdir( cwd );
	return (err1);
}

long part_size = 262144L; /* Default for part-size is 256 kB */


void
retrieve(cmd, fname)
	char *cmd, *fname;
{
	FILE *fin = NULL, *dout = NULL;
	struct stat64 st, junk;
	int (*closefunc)() = NULL;
	int fancy = 0;
/*	static char *fancyname = NULL;
	static int fancynamelen = 0;
	static char *fancycmd = NULL;
	static int fancycmdlen = 0;	*/
	int options = 0;
	char namebuf[MAXPATHLEN+1];
	char namebuf2[MAXPATHLEN+1];
	time_t starttime, endtime;
	long forced_eof = -1;

#include "conversions.h"

	time(&starttime);
	*namebuf  = 0;
	*namebuf2 = 0;

	if ( uploader ) {
	  /* An upload only, but can get READMEs */
	  static char *oknames[] = {
	    "","","-A .","README","CAPTIVE-README","README.UPLOADER",
	    "/README","/CAPTIVE-README","/README.UPLOADER",
	    "/README.IP-REVERSAL","README.IP-REVERSAL",
	    NULL,NULL };
	  char **try = oknames;
	  while (*++try)
	    if (strcmp(*try,fname)==0)
	      break;
	  if (! *try)  {
	    lreply(550,"Sorry Sir/Madam.  You have upload only permission.  No retrievals,");
	    reply(550,"nor argumented directory requests. (plain 'dir' command should work.)");
	    return;
	  }
	}

	if (guest)
	  ftpcnt = logftmp(gttyline,ftmppasswd,remotehost,custlocality,0,Counts);

	if (cmd == 0) {
	  int prefixlen = 0;
	  if (*VirtualChdir) {
	    sprintf(namebuf2,"%s/%s",VirtualChdir,workpath);
	    prettypath(namebuf,namebuf2,fname);
	  } else {
	    prettypath(namebuf,workpath,fname);
	  }
	  canonicpath(namebuf2,namebuf,"");
	  chdir(workpath);

	  if (guest || uploader) {
	    char *s;
	    extern char *RegionDeny();
	    if ((s = RegionDeny(namebuf2))) {
	      lreply(550,"Sorry, this area is closed from your whereabouts.");
	      if (*s) {
		lreply(550,"You may be allowed to access other parts of the archive.");
		reply(550,"%s",s);
	      } else
		reply(550,"You may be allowed to access other parts of the archive.");
	      return;
	    }
	  }

	  if (strncmp(namebuf,workpath,strlen(workpath))==0)
	    prefixlen = strlen(workpath) +1;

	  /* Truncate stderr-dump now! */
	  if (tmperr) {
	    fseek(tmperr,0,SEEK_SET);
	    ftruncate(fileno(tmperr),0);
	  }

	  st.st_size = 0;
	  if (strcmp(namebuf,"/dev/null")==0)
	    { fancy=1; goto BuiltinSenders; }
	  if (strcmp(namebuf,"/dev/1MB")==0)
	    { fancy=1; goto BuiltinSenders; }
	  if (strcmp(namebuf,"/dev/4MB")==0)
	    { fancy=1; goto BuiltinSenders; }
	  if (strcmp(namebuf,"/dev/10MB")==0)
	    { fancy=1; goto BuiltinSenders; }
	  if (strcmp(namebuf,"/dev/30MB")==0)
	    { fancy=1; goto BuiltinSenders; }
	  if (strcmp(namebuf,"/dev/100MB")==0)
	    { fancy=1; goto BuiltinSenders; }
	  if (strncmp(namebuf,"/search:",8)==0) {
	    finder(namebuf+8,NULL);
	    return;
	  }

	  fin = fopen64(namebuf, "r"), closefunc = fclose;

	  st.st_size = 0;
	  /* [mea]  Trying to create some fancy processings... */

	  if (fin == NULL) {
	    char *ptr = strrchr(namebuf,'.');

	    if (ptr != NULL) {
	      char *s;
	      int  partnum = strtol(ptr+1,&s,10);
	      if (*s == 0 && partnum > 0) {
		*ptr = 0;
		fin = fopen64(namebuf, "r"), closefunc = fclose;
	      }
	      --partnum; /* First part is number 1 ! */
	      if (fin != NULL) {
		fstat64(fileno(fin),&st);
		if (partnum * part_size >= st.st_size) {
		  reply(550, "Retrieve attempt beyond the end of file: (%d-1)*%d >= %d",
			partnum+1, part_size, st.st_size);
		  return;
		}
		fseek(fin,partnum*part_size,SEEK_SET);
		forced_eof = part_size;
		/* Fall forward to the real transfer code.. */
	      }
	    }
	  }

	  if( fin == NULL ) {
	    /* Ok, it wasn't a real file, lets see how to create it. */
	    char fnbuf[MAXPATHLEN], *ptr;

	    do {
	      if (cvtptr->postfix) {
		int pfxlen = strlen(cvtptr->postfix);
		int namelen;

		/*if (namelen <= pfxlen) continue;*/
		/* XX: which version ? */
		/* strcpy(fnbuf, namebuf); */
		strcpy(fnbuf, fname);
		namelen = strlen(fnbuf);
		if (strcmp(fnbuf + namelen - pfxlen, cvtptr->postfix))
		  continue;
		fnbuf[namelen - pfxlen] = 0;
		if (lstat64(fnbuf, &st)) continue;

	      } else if (cvtptr->stripfix) {

		/* (void) strcpy(fnbuf, namebuf); */
		strcpy(fnbuf, fname);
		strcat(fnbuf, cvtptr->stripfix);
		if (lstat64(fnbuf, &st)) continue;
	      }

	      if (S_ISDIR(st.st_mode)) {
		if (!(cvtptr->types & T_DIR)) {
		  reply(550, "Cannot %s directories.", cvtptr->name);
		  return;
		}
		if (cvtptr->options & O_TAR) { 
		  strcpy(namebuf2, fnbuf);
		  strcat(namebuf2, "/.notar");
		  if (!lstat64(namebuf2, &junk)) {
		    reply(550,"Sorry, you may not TAR that directory.");
		    return;
		  }
		}
		if (cvtptr->options & O_TAR &&
		    (cvtptr->options & (O_COMPRESS|O_GZIP)) == 0 &&
		    CheckFancyPermit(fnbuf,'T')) {
		  reply(550, "Cannot %s this directory.", cvtptr->name);
		  return;
		}
		if (cvtptr->options & O_TAR &&
		    (cvtptr->options & (O_COMPRESS|O_GZIP)) != 0 &&
		    CheckFancyPermit(fnbuf,'Z')) {
		  reply(550, "Cannot %s this directory.  Possibly plain TAR is allowed.", cvtptr->name);
		  return;
		}
	      }

	      if (S_ISREG(st.st_mode) && !(cvtptr->types & T_REG)) {
		reply(550, "Cannot %s plain files.", cvtptr->name);
		return;
	      }

	      if (!S_ISREG(st.st_mode) && !S_ISDIR(st.st_mode)) {
		reply(550, "Cannot %s special files.", cvtptr->name);
		return;
	      }

	      if (!(cvtptr->types & T_ASCII) && deny_badasciixfer(550,""))
		return;

	      options |= cvtptr->options;

	      findpathcmd(namebuf2, cvtptr->external_cmd);
	      if ((ptr = strchr(namebuf2, ' ')) != NULL)
		*ptr = '\0';
	      if (lstat64(namebuf2, &st) != NULL) {
		syslog(LOG_ERR, "external command %s not found",
		       namebuf2);
		reply(550,
		      "Local error: conversion program not found. Cannot %s file.",
		      cvtptr->name);
		return;
	      }
	      *ptr = ' ';
	      (void) retrieve(namebuf2, fnbuf);

	      strcpy(namebuf,fnbuf);
	      goto done;
	    } while ((++cvtptr)->name);
	  }			/* fin == NULL */
	  /* Ok, either conversion started, or we have
	     a handle to an ordinary file		*/
	  /* cmd == 0 */
	} else { /* cmd != NULL -- we run some command! */

	  char line[BUFSIZ];
	  *line = 0;

	  /* Truncate stderr-dump now! */
	  if (tmperr) {
	    fseek(tmperr,0,SEEK_SET);
	    ftruncate(fileno(tmperr),0);
	  }

	  findpathcmd(namebuf2, cmd);
	  strcpy(namebuf,fname);
	  (void) sprintf(line, namebuf2, fname) /*, namebuf = line*/;
	  fin = ftpd_popen(line, "r"), closefunc = ftpd_pclose;
	  st.st_size = -1;
#ifndef	USG
	  st.st_blksize = BUFSIZ;
#endif
	}
	if (fin == NULL) {
	  if (errno != 0)
	    perror_reply(550, namebuf);
	  return;
	}
	if (restart_point) {
	  if (type == TYPE_A) {
	    register int i,n,c;
	    n = restart_point;
	    i = 0;
	    while (i++ < n) {
	      if ((c = getc(fin)) == EOF) {
		perror_reply(550, namebuf);
		goto done;
	      }
	      if (c == '\n')
		++i;
	    }
	  } else if (lseek(fileno(fin),restart_point, SEEK_SET) < 0) {
	    perror_reply(550, namebuf);
	    goto done;
	  }
	}
	if (cmd == 0 &&
	    (fstat64(fileno(fin), &st) < 0 || !S_ISREG(st.st_mode))) {
		reply(550, "%s: not a plain file.", fname);
		goto done;
	}
BuiltinSenders:
	dout = dataconn(namebuf, st.st_size, "w", fancy);
	if (dout == NULL)
		goto done;
	time(&starttime);
#ifndef	USG
	send_data(fin, dout, st.st_blksize,closefunc,fancy,namebuf,forced_eof);
#else
	send_data(fin, dout, BUFSIZ,closefunc,fancy,namebuf,forced_eof);
#endif
	(void) fclose(dout);
	data = -1;
	pdata = -1;
	goto done2;
done:	;
done2:	;
	time(&endtime);
	if (fin && closefunc) (*closefunc)(fin);
	if (guest) {
	  if (cmd!=NULL)
	    AccessLogging("C %d %s '%s' %lld %s %s", (int)getpid(), remotehostname, workpath, byte_count, cmd, namebuf);
	  else
	    AccessLogging("R %d %s '%s' %lld %ld %s", (int)getpid(), remotehostname, workpath, byte_count, endtime-starttime, namebuf);
	} else if (non_anonymous) {
	  if (cmd!=NULL)
	    AccessLogging("CN %d %s '%s' %lld %s %s", (int)getpid(), remotehostname, workpath, byte_count, cmd, namebuf);
	  else
	    AccessLogging("RN %d %s '%s' %lld %ld %s", getpid(), remotehostname, workpath, byte_count, endtime-starttime, namebuf);
	}
}


void
retrieve_readme(filename)
char *filename;
{
	/* XX: SERIOUS KLUDGE!
	   To let user to retrieve system README* -files
	   without being logged in! */
	char readmepath[100];
	int prefixlen = 0;
	struct passwd *pw = getpwnam("ftp");

	if (!pw) {
	  lreply(500,"Sorry, no ANONYMOUS file store to retrieve `%s' from!",filename);
	  return;
	}
	strcpy(readmepath,pw->pw_dir);
	strcat(readmepath,"/");
	prefixlen = strlen(readmepath);
	strncpy(readmepath+prefixlen,
		filename,
		sizeof(readmepath)-prefixlen-1);
	readmepath[sizeof(readmepath)-1] = 0;
	retrieve(NULL, readmepath);
}
