#include "ftpd.c"

extern FILE *tmperr;

void
statfilecmd(filename)
	char *filename;
{
	char line[BUFSIZ];
	char cmdname[20], cmdrest[30];
	FILE *fin;
	int c;

	sscanf(LISTcmdstr,"%s%[^\n]",cmdname,cmdrest);
	findpathcmd(line, cmdname);
	(void) sprintf(line+strlen(line), cmdrest, filename);
	fin = ftpd_popen(line, "r");
	lreply(211, "status of %s:", filename);
	while ((c = getc(fin)) != EOF) {
		if (c == '\n') {
			if (ferror(stdout)){
				perror_reply(421, "control connection");
				(void) ftpd_pclose(fin);
				dologout(1);
				/* NOTREACHED */
			}
			if (ferror(fin)) {
			  int e = errno;
			  reply(551, "File %s pclose_status: 0x%X; errno= %d / %s",
				filename, ftpd_pclose(fin), e, strerror(e));
			  return;
			}
			(void) putc('\r', stdout);
		}
		(void) putc(c, stdout);
	}
	lreplys(211, tmperr, "Previous subprocess reported following error(s) to stderr:","");
	reply(211, "End of Status: 0x%X",ftpd_pclose(fin));
}

int subproc_stat_loc = 0;

void
statcmd()
{
	struct sockaddr_in *sin;
	u_char *a, *P;
	char line[256], *p;

	lreply(211, "%s FTP server status:", hostname, version);
	lreply(-211,"%s", version);
	sprintf(line,"Connected to %s", remotehost);
	if (!isdigit(remotehost[0]))
	  sprintf(line+strlen(line)," (%s)", inet_ntoa(his_addr.sin_addr));
	lreply(-211,"%s",line);
	if (logged_in) {
	  if (guest)
	    lreply(-211,"Logged in anonymously with `passwd' of: `%s'",
		   ftmppasswd);
	  else
	    lreply(-211,"Logged in as %s, uid %d (%d)",
		   pw->pw_name, user_uid, geteuid());
	} else if (askpasswd)
	  lreply(-211,"Waiting for password");
	else
	   lreply(-211,"Waiting for user name");
	sprintf(line,"TYPE: %s", typenames[type]);
	p = line;
	p = p + strlen(p);
	if (type == TYPE_A || type == TYPE_E)
	  sprintf(p,", FORM: %s", formnames[form]);
	p = p + strlen(p);
	if (type == TYPE_L)
#if NBBY == 8
	  sprintf(p," %d", NBBY);
#else
	sprintf(p," %d", bytesize);	/* need definition! */
#endif
	p = p + strlen(p);
	sprintf(p,"; STRUcture: %s; transfer MODE: %s",
		strunames[stru], modenames[mode]);
	lreply(-211,"%s",line);
	if (data != -1)
	  lreply(-211,"Data connection open");
	else if (pdata != -1) {
	  strcpy(line,"in Passive mode");
	  sin = &pasv_addr;
	  goto printaddr;
	} else if (usedefault == 0) {
	  strcpy(line,"PORT");
	  sin = &data_dest;
printaddr:
	  p = line;
	  p = p + strlen(p);
	  a = (u_char *) &sin->sin_addr;
	  P = (u_char *) &sin->sin_port;
#define UC(b) (((int) b) & 0xff)
	  sprintf(p," (%d,%d,%d,%d,%d,%d)\r\n", UC(a[0]),
		 UC(a[1]), UC(a[2]), UC(a[3]), UC(P[0]), UC(P[1]));
#undef UC
	  lreply(-211,"%s",line);
	} else
	  lreply(-211,"No data connection");
	if (!tmperr)
	  lreply(-211,"No internal stderr-dump.");
	else
	  lreply(-211,"Internal stderr-dump present, fileno:%d",
		 fileno(tmperr));
	lreply(-211,"Last subprocess had status: 0x%04x",subproc_stat_loc);
	lreplys(211, tmperr, "Previous subprocess reported following error(s) to stderr:","");
	reply(211, "End of status");
}
