/* USER and PASS commands with site dependent responce texts..

   This bases on BSD 4.3-Tahoe FTPD source.
*/

extern void endusershell(void);

#define AccessLogging jdfhjsfdjh
#include "ftpd.c"
#undef AccessLogging

#ifdef	USE_SHADOW
#include <shadow.h>
#endif
#include <sys/time.h>

extern char *ClassReadme; /* Does current userclass have a special readme ? */
extern char  envFTPD[MAXPATHLEN];
extern char *sgetsave();
extern char TZ[];

extern void end_login();


/*
 * Helper function for sgetpwnam().
 */
char *
sgetsave(s)
	char *s;
{
	unsigned int len;
	char *new;

	if (s == NULL) return NULL;

	len = strlen(s);
	new = malloc(len +1);

	if (new == NULL) {
		perror_reply(421, "Local resource failure: malloc()");
		dologout(1);
		/* NOTREACHED */
	}
	strcpy(new, s);
	return (new);
}

/*
 * Save the result of a getpwnam.  Used for USER command, since
 * the data returned must not be clobbered by any other command
 * (e.g., globbing).
 */
struct passwd *
sgetpwnam(name)
	char *name;
{
	static struct passwd save;
#ifdef	USE_SHADOW
	struct spwd *sp;
#endif
	register struct passwd *p;
#ifdef	SecureWare
	struct pr_passwd *pr;
#endif


#ifdef	SecureWare
	pr = getprpwnam(name);
	if (pr == NULL)
		return NULL;
#endif
	p = getpwnam(name);	/* We need this ALWAYS */
	if (p == NULL)
		return NULL;

	if (save.pw_name)	free(save.pw_name);
	if (save.pw_passwd)	free(save.pw_passwd);
	if (save.pw_gecos)	free(save.pw_gecos);
	if (save.pw_dir)	free(save.pw_dir);
	if (save.pw_shell)	free(save.pw_shell);

	save.pw_uid   = p->pw_uid;
	save.pw_gid   = p->pw_gid;
	save.pw_name  = sgetsave(p->pw_name);
	save.pw_gecos = sgetsave(p->pw_gecos);
	save.pw_dir   = sgetsave(p->pw_dir);
	save.pw_shell = sgetsave(p->pw_shell);

#ifdef	USE_SHADOW

	sp = getspnam(name);
	if (!sp)
	  save.pw_passwd = NULL;
	else if (!(sp->sp_pwdp) || *(sp->sp_pwdp) == 0)
	  save.pw_passwd = "";
	else
	  save.pw_passwd = sgetsave(sp->sp_pwdp);
	endspent(); /* Close the shadow file */
#elif defined(SecureWare)
	if (pr->uflg.fg_encrypt && pr->ufld.fd_encrypt && *pr->ufld.fd_encrypt)
	  save.pw_passwd = sgetsave(pr->ufld.fd_encrypt);
	else
	  save.pw_passwd = sgetsave("");
#else
	save.pw_passwd = sgetsave(p->pw_passwd);
#endif

#ifdef	SecureWare
	endprpwent();
#endif
	return (&save);
}

/*
 * USER command.
 * Sets global passwd pointer pw if named account exists
 * and is acceptable; sets askpasswd if a PASS command is
 * expected. If logged in previously, need to reset state.
 * If name is "ftp" or "anonymous" and ftp account exists,
 * set guest and pw, then just return.
 * If account doesn't exist, ask for passwd anyway.
 * Otherwise, check user requesting login privileges.
 * Disallow anyone who does not have a standard
 * shell returned by getusershell() (/etc/shells).
 * Disallow anyone mentioned in the file FTPUSERS
 * to allow people such as root and uucp to be avoided.
 * If there is a name with "+" -prefix, those names are non-anonymous
 * anonymous users -- they can do only ftp, but they are not anonymous.
 */

static char ftmpuser[20] = "";

void
user(name)
	char *name;
{
	register char *cp;
	FILE *fd;
	char *shell;
	char line[BUFSIZ], *getusershell();
	struct in_addr haddr;
	struct stat statbuf;

	haddr.s_addr = his_addr.sin_addr.s_addr;

	if (logged_in) {
	  if (guest) {
	    reply(530, "Can't change user from guest login.");
	    end_login("Can't change user from guest login.");
	    return;
	  }
	}

	guest = 0;
	envFTPD[0] = '_';
	uploader = 0;
	unlimited = 0;
	non_anonymous = 0;
	*ftmpuser = 0;
	if (strcasecmp("anonymous",name) == 0 ||
	    strcasecmp("pictures",name) == 0 ||
	    strcasecmp("ftp",name) ==0) {
	  strncpy(ftmpuser,name,sizeof(ftmpuser)-1);
	  ftmpuser[sizeof(ftmpuser)-1] = 0;
	  /* We do ftmp logging and find out how many
	     anonymouses we have simultaneously		 */
	  custlocality = AnalCustLocality(&haddr, remotehostname, ftmpuser, 0);
	  if (stat(FTPDBLOCKED,&statbuf)==0) {
	    char *s;
	    char line[BUFSIZ];
	    FILE *CustMsgFd = fopen(FTPDBLOCKED,"r");
	    if (CustMsgFd != NULL) {
	      fseek(CustMsgFd,0,0);
	      while(!ferror(CustMsgFd) && !feof(CustMsgFd)) {
		*line = 0;
		if (fgets(line,sizeof(line)-1,CustMsgFd) == NULL) break;
		if ((s = (char*)strchr(line,'\n'))) *s= 0;
		lreply(421,"%s",line);
	      }
	    }
	    fclose(CustMsgFd);
	    reply(421,"Sorry, service blocked for a moment, try again later.");
	    end_login("Service blocked for a moment..");
	    exit(0);
	  }
	  strcpy( ftmppasswd,"USER-command" );
	  ftpcnt = logftmp(gttyline,ftmppasswd,remotehost,custlocality,1,Counts);
#if 0
	  if (Counts[custlocality] > Maxanonymous[custlocality]) {
	    /* if (!remotenameOK && !AllowAccess) {
	       captivity = 1 ;
	       lreply(421,"Your IP address doesn't translate to name. You can only read /README,");
	       lreply(421," and /CAPTIVE-README!  Very least read the later one!");
	       }*/
	    lreply(421,"Too many anonymous ftp users at the moment in your class.");
	    lreply(421,"Your class is named: %s",ClassName[custlocality]);
	    reply(421,"Please try again later.");
	    /* Forget all about it... */
	    end_login("Too many anonymous");
	    exit(0);		/* We leave it... */
	  }
#endif
	}
	if (strcasecmp(name, "ftp") ==0
	    || strcasecmp(name, "anonymous") ==0
	    || strcasecmp(name, "pictures") ==0
	    || strcasecmp(name, "uploader") ==0) {
	  if ((pw = sgetpwnam("ftp")) != NULL) {
	    guest = 1;
	    askpasswd = 1;
	    uploader = (strcasecmp(name,"uploader")==0);
	    if (uploader) {
	      lreply(331,"Uploader guest ok, can ONLY store, no retrieve.");
	      lreply(331," ... well, get /README.UPLOADER for the details :-)");
	    }
	    if (strcasecmp(name,"anonymous")==0 &&
		strcmp(name,"anonymous") != 0) {
	      lreply(331,"Guest login ok, give your E-mail address for password.");
	      lreply(331,"NOTE: You typed `anonymous' in mixed/upper case form.");
	      reply(331,"      You will need lowercase for most files in this system!");
	    } else
	      reply(331,"Guest login ok, give your E-mail address for password.");
	  } else
	    reply(530, "User %s unknown.", name);
	  envFTPD[0] = ((guest || non_anonymous) ? 'F' : '_');
	  return;
	}
	if ((pw = sgetpwnam(name))) {
	  if ((fd = fopen(FTPUSERS, "r")) != NULL) {
	    while (fgets(line, sizeof (line), fd) != NULL) {
	      if ((cp = strchr(line, '\n')) != NULL)
		*cp = '\0';
	      if ((cp = strchr(line,'\t'))) {*cp = 0;++cp;}
	      else if ((cp = strchr(line,' ')))  {*cp = 0;++cp;}
	      else cp = "blacklisted";
	      if (strcmp(line,name) == 0) {
		reply(530, "User %s access denied - %s",name,cp);
		if (logging)
		  syslog(LOG_NOTICE,
			 "FTP LOGIN REFUSED FROM %s, %s - %s",
			 remotehost, name, cp);
		pw = (struct passwd *) NULL;
		fclose(fd);
		return;
	      }
if (debug) syslog(LOG_NOTICE, "FTPUSER test: '%s' vs. '%s'",line,name);
	      if (*line == '+' && strcmp(line+1,name)==0) {
		non_anonymous = 1;
		break;
	      }
	      if (*line == '*' && strcmp(line+1,name)==0) {
		non_anonymous = 0;
		guest = 1;
		break;
	      }
	    } /* while */
	    fclose(fd);
	  }
	  if ((shell = pw->pw_shell) == NULL || *shell == 0)
	    shell = "/bin/sh";
	  while ((cp = getusershell()) != NULL)
	    if (strcmp(cp, shell) == 0)
	      break;
	  endusershell();
	  if (cp == NULL && !non_anonymous) {
	    reply(530, "User %s access denied - bad shell.", name);
	    if (logging)
	      syslog(LOG_NOTICE,
		     "FTP LOGIN REFUSED FROM %s, %s - bad shell",
		     remotehost, name);
	    pw = (struct passwd *) NULL;
	    return;
	  }
	}
	if (guest)
	  reply(331, "Guest login ok, give your E-mail address for password.");
	else
	  reply(331, "Password required for %s.", name);
	askpasswd = 1;
	/*
	 * Delay before reading passwd after first failed
	 * attempt to slow down passwd-guessing programs.
	 */
	if (login_attempts)
		sleep((unsigned) login_attempts*5);

	envFTPD[0] = ((guest || non_anonymous) ? 'F' : '_');
}

/*
 * Terminate login as previous user, if any, resetting state;
 * used when USER command is given or login fails.
 */
void
end_login(why)
     char *why;
{
	int guestcnt = 0;

	seteuid((uid_t)0);
	if (logged_in)
		logwtmp(ttyline, "", "");
#if 0
	if (!logged_in || guest)
	  guestcnt = endftmp(gttyline,ftmppasswd,remotehost,custlocality,NULL);
#else
	endftmp();
#endif
	cumul_bytes += byte_count;
	byte_count = 0;
#ifdef DO_SYSLOG_VERBOSE
	syslog(FTP_LOG_PRIORITY,"Ending %s with %d bytes fetched (guestcnt now=%d) because %s",
	       remotehost,cumul_bytes,guestcnt,why);
#endif
	pw = NULL;
	logged_in = 0;
	guest = 0;
	cumul_bytes = 0;
	envFTPD[0] = '_';
}


static int LoggingFD = -1;

void
SetupLogging()
{
  extern time_t time();

  char filename[sizeof(ACCESSLOGDIR)+20];
  struct tm *tp;
  time_t logtime = time(NULL);
  int oldumask = umask(022);

  tp = localtime(&logtime);
  strcpy(filename,ACCESSLOGDIR);
  if (tp != NULL)
    /* Y2K fix <hks>
    sprintf(filename+strlen(filename),"/%02d%02d/%02d%02d%02d",
	    tp->tm_year,tp->tm_mon+1,
	    tp->tm_year,tp->tm_mon+1,tp->tm_mday);


    */
    sprintf(filename+strlen(filename),"/%04d%02d/%04d%02d%02d",
	    tp->tm_year+1900,tp->tm_mon+1,
	    tp->tm_year+1900,tp->tm_mon+1,tp->tm_mday);

  LoggingFD = open( filename, O_WRONLY|O_APPEND|O_CREAT, 0644 );
  if (LoggingFD < 0) {
    char *s = strrchr(filename,'/');
    if (s != NULL) {
      *s = 0;
      mkdir(filename,0755);
      *s = '/';
      LoggingFD = open( filename, O_WRONLY|O_APPEND|O_CREAT, 0644 );
    }
  }
  umask(oldumask);

  /* Several programs use  /var/adm/ftpd.log  to store their access logs
     into the logs as well -- mailserver among them. */
}

/* VARARGS2 */
void
AccessLogging(va_alist)
	va_dcl
{
	int len;
	char buf[1024];
	char *fmt;
	va_list ap;

	if (LoggingFD < 0 || (!guest && !non_anonymous)) return;

	va_start(ap);

	fmt = va_arg(ap, char *);

	vsprintf(buf,fmt,ap);
	va_end (ap);
	len = strlen(buf);
	strcat( buf+len,"\n" );

	write( LoggingFD,buf,len+1 );
}



static FILE *CustMsgFd = NULL;

void
CheckCustomerMessages()
{
  CustMsgFd= fopen(CUSTMSGFILE,"r");
}

char *OrderStr(n)
int n;
{
	static char line[10];

	if(n==1) return "first";
	if(n==2) return "second";
	if(n==3) return "third";
	sprintf( line,"%dth",n );
	return line;
}

void
DisplayCustomerMessages(code)
     int code;
{
	char *s;
	char line[BUFSIZ];
	struct tm *local_time;
	time_t t;
	FILE *messagefile, *motd;

	if (!non_anonymous) {
	  if (Counts[custlocality] >= 0)
	    lreply(code,
		   "Welcome, you are %s archive user in your class (max %d).",
		   OrderStr(Counts[custlocality]),Maxanonymous[custlocality]);
	  lreply(code,"Your class is named: %s",
		 ClassName[custlocality] ? ClassName[custlocality] :
		 "*NO NAME DEFINED*");
	  lreply(code,"There are %d users in all classes (max %d)",
		 ftpcnt,maxanonymoussum);
	  if (Counts[custlocality] > Maxanonymous[custlocality]) {
	    lreply(220,"Of those, %d are attempting to come in, but are over the logon",
		   Counts[custlocality] - Maxanonymous[custlocality]);
	    lreply(220,"quota, and will be refused at the moment.  You have passed this limit.");
	  }

	  {	
	    /* Now figure what to tell about the transfer rate.. */
	    int __limitrate;
	    int __myClSndrs;
	     
	    getsetftmpBps(0,0,0,0,0,0,NULL,&__myClSndrs);
	    ++__myClSndrs;
#define SUFFIXDIV(rate) ( (rate>2048)?((rate>1048575)?rate>>20:rate>>10):rate )
#define SUFFIXER(rate) ( (rate>2048) ?((rate>1048575)?"MB":"kB"):"B" )
	    __limitrate = (Maxsendrate[custlocality]*
			   Maxanonymous[custlocality])/__myClSndrs;
	    if (__limitrate > Absmaxsendrate[custlocality])
	      __limitrate = Absmaxsendrate[custlocality];
	    if (__limitrate != 0 /* not unlimited */ ) {
	      lreply(code,"The maximum bandwidth allocated for you is limited.  It can be as");
	      lreply(code,"low as %d %s/s.  At this moment it would set to %d %s/s.",
		     SUFFIXDIV(Maxsendrate[custlocality]),
		     SUFFIXER(Maxsendrate[custlocality]),
		     SUFFIXDIV(__limitrate),SUFFIXER(__limitrate));
	    } else
	      lreply(code,"Your data-transfer rate has no limitations.");
	  }
	} /* if !unlimited */
	
	if ((motd = fopen (ICMOTD, "r")) != NULL) {
	  while (!ferror(motd) && !feof(motd) &&
		 fgets(line,sizeof(line)-1,motd)!=NULL) {
	    if ((s = (char *)strchr(line, '\n')) != NULL) *s = 0;
	    lreply(code,"%s",line);
	  }
	  fclose (motd);
	}
	
	time (&t);
	lreply(code,"");
	lreply(code,"Local time is %24.24s %s",ctime(&t),TZ);
	lreply(code,"");
	
	if (!non_anonymous) {
	     
	  if (custlocality != CUST_LOCAL) {
	    if ((messagefile=fopen(FOREIGNMSGFILE, "r")) != NULL) {
	      while (!ferror(messagefile) && !feof(messagefile) &&
		     (fgets(line,sizeof(line)-1,messagefile)!=NULL)) {
		if ((s = (char*)strchr(line, '\n'))!=NULL)
		  *s=0;
		lreply(code,"%s",line);
	      }
	      lreply(code,"");
	      fclose(messagefile);
	    }
	  }
	     
	  if (CustMsgFd == NULL) return;
	  fseek(CustMsgFd,0,0);
	  while (!ferror(CustMsgFd) && !feof(CustMsgFd)) {
	    *line = 0;
	    if (fgets(line,sizeof(line)-1,CustMsgFd) == NULL) break;
	    if ((s = (char*)strchr(line,'\n'))) *s= 0;
	    lreply(code,"%s",line);
	  }
	  /*  fclose(CustMsgFd);*/
	}
   }

void
pass(passwdin)
char *passwdin;
{
	char *s, *s2;
	char topdomain[32]; /* it is enough ? */
	static char passwdb[256];
	char *passwd = passwdb;
	time_t t;
	extern time_t login_time;
	struct in_addr haddr;
	char ddd[200];
	struct stat stats;
	int rc;
	int bad_passwd = 0;
	extern int AllowAccess;
	int initial_custlocality;
	char VirtualChroot[512];

	strncpy(passwdb,passwdin,sizeof(passwdb));
	passwdb[sizeof(passwdb)-1] = 0;

	no_lreplyo = no_lreply = (*passwd == '-');
	
	if (*passwd == '-')
	  ++passwd;

	if (logged_in || askpasswd == 0) {
		reply(503, "Login with USER first.");
		return;
	}
	askpasswd = 0;
	if (!guest) {		/* "ftp" is only account allowed no password */
		int passwd_match = 0;
		char *xpasswd = "XX";
		char *salt    = "xx";
#ifdef	USE_PWDAUTH
		if (issecure()) {
			passwd_match = (pw && !pwdauth(pw->pw_name,passwd));
		} else {
#endif

		char passbuf[30];
		strncpy(passbuf, passwd, sizeof(passbuf));
		if (pw == NULL)
			salt = "xx";
		else
			salt = pw->pw_passwd;
#ifdef SecureWare
		xpasswd = bigcrypt(passbuf, salt);
#else		
		xpasswd = crypt(passbuf, salt);
#endif

		/* The strcmp does not catch null passwords! */
		passwd_match = !(pw == NULL || pw->pw_passwd[0] == '\0' ||
				 strcmp(xpasswd, pw->pw_passwd) != 0);
#ifdef USE_PWDAUTH
		}
#endif
		if (!passwd_match) {
/*
lreply(530,"DEBUG: pwd='%s', xpasswd='%s', pw->pw_passwd='%s', salt='%s'",
       passwd,
       xpasswd ? xpasswd : "{null}",
       pw->pw_passwd, salt);
*/
			reply(530, "Login incorrect.");
			pw = NULL;
			if (login_attempts++ >= 5) {
				syslog(LOG_NOTICE,
				       "repeated login failures from %s",
				       remotehost);
				end_login("Repeated login failures");
				exit(0);
			}
			return;
		}
	}
	login_attempts = 0;		/* this time successful */
	setgid((gid_t)pw->pw_gid); /* We are super-user when we do
				      this, thus  setegid() is not
				      needed.. */
#if	defined(_POSIX_SOURCE) || defined(BSD) || defined(sun)
#ifndef	ISC
	initgroups(pw->pw_name, pw->pw_gid);
#endif
#endif

	logged_in = 1;

	/* We do ftmp logging and find out how many
	   anonymouses we have simultaneously		 */
	*topdomain = 0; topdomain[sizeof(topdomain)-1]=0;
	sprintf(gttyline, "ttyp%d", (int)getpid());
	sprintf(remotehost,"%s",inet_ntoa(his_addr.sin_addr));
	if (!guest)
	  strcat( ftmppasswd,"<real_user>" );
	

	/* open wtmp before chroot */
	sprintf(ttyline, "fp%05d",(int)getpid());
	strcpy(unameline,pw->pw_name);
	if (guest)
		sprintf(unameline,"%s-%d",pw->pw_name,(int)getpid());
	logwtmp(ttyline, unameline, remotehost);

	haddr.s_addr = his_addr.sin_addr.s_addr;

	if (strncmp(passwd,"gopher@",7)==0) {
	  strcpy(remotehostname,passwd+7);
	  if ((int)inet_addr(remotehostname) != -1)
	    sprintf(remotehostname,"[%s]",passwd+7);
	}

	if (guest) {
	  /* Lets see, if remotehostname isn't valid, but password
	     has part after '@' which has same IP network, as users
	     host has. */

	  s = strrchr(passwd,'@');
	  if (s && *remotehostname == '[' ) {
	    /* Lets try to see if  his_addr can be found from string
	       following the `@' character :-) */
	    struct hostent *hp = gethostbyname(s+1);
	    if( hp == NULL && h_errno == TRY_AGAIN )
	      /* Well, we try again.. once */
	      hp = gethostbyname(s+1);
	    if ( hp != NULL && addr_match(hp,&his_addr)) {
	      strcpy(remotehostname,s+1);
	      remotenameOK = 1;
	    }
	  }
	  if (s && s[1] == 0 && remotenameOK) {
	    strcpy(s+1,remotehostname);
	  }
	}

	initial_custlocality = custlocality;
	custlocality = AnalCustLocality(&haddr, remotehostname, ftmpuser,
					strncmp(passwd,"foreign",7)==0);


	CheckCustomerMessages();
	SetupLogging();
	if (non_anonymous) {
	  if (chroot(pw->pw_dir) < 0 || chdir("/") < 0) {
	    reply(550, "Can't set guest privileges.");
	    goto bad;
	  }
	} else if (guest) {
	  /* We do ftmp logging and find out how many
	     anonymouses we have simultaneously		 */
	  strncpy( ftmppasswd,passwd,sizeof(ftmppasswd)- 1 );
	  ftmppasswd[sizeof(ftmppasswd)- 1] = 0;

	  /* Change of classification ? */
	  ftpcnt = logftmp(gttyline,ftmppasswd,remotehost,
			   custlocality,1,Counts);

	  if (!uploader &&
	      Counts[custlocality] > Maxanonymous[custlocality]) {
	    if (!remotenameOK && !AllowAccess) {
	       captivity = 1 ;
	       lreply(421,"Your IP address doesn't translate to name. You can only read /README,");
	       lreply(421," and /CAPTIVE-README!  Very least read the later one!");
	       }
	    lreply(421,"Too many anonymous ftp users at the moment in your class.");
	    lreply(421,"Your class is named: %s",ClassName[custlocality]);
	    lreply(421,"Counted users are %d (max %d)",
		   Counts[custlocality],Maxanonymous[custlocality]);
	    reply(421,"Please try again later.");
	    /* Forget all about it... */
	    end_login("Too many anonymous");
	    exit(0);		/* We leave it... */
	  }

	  /*
	   * We MUST do a chdir() after the chroot. Otherwise
	   * the old current directory will be accessible as "."
	   * outside the new root!
	   */
	  if (chroot(pw->pw_dir) < 0 || chdir("/") < 0) {
	    reply(550, "Can't set guest privileges.");
	    goto bad;
	  }
	  strcpy(workpath,"/");	/* Initialize workpath to be the root.. */
	  if (VirtualMatch(&ctrl_addr,VirtualChroot,VirtualChdir)) {
	    chroot(VirtualChroot);
	    chdir("/");
	    chdir(VirtualChdir);
	    strcpy(workpath,VirtualChdir);
	    lreply(230, "VirtualChroot='%s' VirtualChdir='%s'",
		   VirtualChroot,VirtualChdir);
	  }
	} else if (chdir(pw->pw_dir) < 0) {
	  if (chdir("/") < 0) {
	    reply(530, "User %s: can't change directory to %s.",
		  pw->pw_name, pw->pw_dir);
	    goto bad;
	  } else
	    lreply(230, "No directory! Logging in with home=/");
	  strcpy(workpath,"/");	/* Initialize workpath to be the root.. */
	} else
	  strcpy(workpath,pw->pw_dir);

	if (guest) {

	  extern char *rfc821_path2();
	  extern char *rfc821_error;
	  extern char *rfc821_error_ptr;

	  /* Right, successfull or not, continue with other buggings */

	  if (!remotenameOK && AllowAccess) {
	    /* lreply(230,"Your IP address doesn't translate to name. You can only read /README, and /CAPTIVE-README!"); */
	    lreply(230,"Your IP address doesn't translate to name. Retrieve and read /README, and /CAPTIVE-README!");
	    /* captivity = 1; */
	  }
	  s2 = (char*)rfc821_path2(passwd,0);
	  s = strchr(passwd,'@');
	  if (s > passwd && *(s+1)==0 && remotenameOK) {
	    /* "user@" -- remote name can be appended to the password */
	    /* XX: strcat() to passwd ?? */
	    lreply(230, "Guest `%s'(%s) login ok.",passwd,remotehostname);
	  } else if( s == NULL || strlen(passwd) < 3 /* No @, or too short! */) {
	    bad_passwd = 1;
	    lreply(230, "You didn't give your Internet E-mail address as the password.");
	    lreply(230, "You gave: `%s'",passwd);
	    if (rfc821_error_ptr)
	      lreply(230, "           %*s^-- %s",
		     (int)(passwd +1 - rfc821_error_ptr), "", rfc821_error);
	    lreply(-230, "Examples:");
	    if (*remotehostname != '[')
	      lreply(-230, "      Firstname.Lastname@%s",remotehostname);
	    else
	      lreply(-230, "      Your.Name@Your.Domain.Address");
	    if (strlen(passwd)==8) {
	      lreply(-230, "Your FTP-client may use faulty method on collecting the password entry.");
	      lreply(-230, "See the /README for more information!");
	    }
	    /* remotenameOK = 0;*/
	  } else if (s2 == passwd || *(s+1) == '[' || *(s+1) == 0) {
	    bad_passwd = 1;
            lreply(230, "You didn't give your Internet E-mail address as the password.");
            lreply(230, "You gave: `%s'",passwd);
	    if (rfc821_error_ptr)
	      lreply(230, "          %*s^-- %s",
		     (int)(passwd +1 - rfc821_error_ptr), "", rfc821_error);
	    lreply(-230, "Examples:");
	    if (*remotehostname != '[')
	      lreply(-230, "      Firstname.Lastname@%s",remotehostname);
	    else
	      lreply(-230, "      Your.Name@Your.Domain.Address");
	    /* remotenameOK = 0;*/
	  } else {
	       lreply(230, "Guest `%s' login ok.",passwd);
	  }

	  PrintBanner200(230,banner230);
	  DisplayCustomerMessages(230 /* , ftpcnt,
					 Maxanonymous[custlocality],
					 custlocality */ );

	  if (no_lreply) {
	    no_lreply = 0;
	    lreply(230,"Intermediate replies disabled.  Some information may get lost.");
	    no_lreply = 1;
	  }
/*        if (!remotenameOK && (AllowAccess!=0)) {*/
	    if (bad_passwd) {
	      no_lreply = 0;
/*	      if (bad_passwd)
	        lreply(-230,"Your IP number didn't reverse, and/or password wasn't ok as E-mail address.");
	      else
	        lreply(-230,"Your IP number didn't reverse.");
	      lreply(-230,"Read   /CAPTIVE-README  for further information!");
	      lreply(230, "");*/
	      lreply(230, "You entered an invalid/improbable password, and are now accessing");
	      lreply(230, "restricted subset of files.    Please read README for more information.");
	      captivity = 1;
	      rc = chroot(".badloginroot");
	      if (rc < 0) {
		lreply(-230,"Err from chroot(): %d (%s)",errno,sys_errlist[errno]);
	      }
	      rc = chdir("/");
	      strcpy(workpath,"/"); /* Initialize workpath to be the root.. */
	      if (rc < 0) {
		lreply(-230,"Err from chdir(): %d (%s)",errno,sys_errlist[errno]);
		/* Ah well...	Here it is not so bad to fail chroot()
				Higer up it IS! */
	      }
	      no_lreply = no_lreplyo;
	    }
	  if (stat("/README",&stats)==0 ) {
	    lreply(230, "We have special access features, see file README");
	    strcpy(ddd,ctime(&stats.st_mtime));
	    ddd[24] = 0;
	    lreply (230,
		    "  It was last updated %s - %3.1f days ago",ddd,
		    (double)(time(0)-stats.st_mtime)/86400.0);
	  }
	  if(ClassReadme && stat(ClassReadme,&stats)==0 ) {
	    lreply(230, "Your usage group has a special README file: %s",
		   ClassReadme);
	    strcpy(ddd,ctime(&stats.st_mtime));
	    ddd[24] = 0;
	    lreply (230,
		    "  It was last updated %s - %3.1f days ago",ddd,
		    (double)(time(0)-stats.st_mtime)/86400.0);
	  }
	  {
	    FILE *msg = fopen(".message","r");
	    if (!msg) msg = fopen(".readme","r");
	    if (msg) {
	      /* Reusing ddd[] */
	      char *s;
	      while (!feof(msg) && !ferror(msg)) {
		if (fgets(ddd,sizeof(ddd)-1,msg) == NULL) break;
		if ((s = strchr(ddd,'\n')) != NULL) *s = 0;
		lreply(250, "%s", ddd);
	      }
	    }
	  }

	  reply(230,"");

#ifdef SETPROCTITLE
	  sprintf(proctitle, "%s: ftp/%.*s", remotehost,
		  sizeof(proctitle) - sizeof(remotehost) -
		  sizeof(": ftp/"), passwd);
	  setproctitle("%s",proctitle);
#endif /* SETPROCTITLE */
	  if (logging)
	    syslog(FTP_LOG_PRIORITY, "ANONYMOUS FTP LOGIN FROM %s, %s",
		   remotehost, passwd);
	} else {
	  reply(230, "User `%s' logged in%s. (guest=%d)", pw->pw_name,
		non_anonymous ? "to anonymous filesystem" : "", guest);
#ifdef SETPROCTITLE
	  sprintf(proctitle, "%s: %s", remotehost, pw->pw_name);
	  setproctitle("%s",proctitle);
#endif /* SETPROCTITLE */
	  if (logging)
	    syslog(FTP_LOG_PRIORITY, "FTP LOGIN FROM %s, %s",
		   remotehost, pw->pw_name);
	}
	user_uid = pw->pw_uid;
	if (seteuid(user_uid) < 0) {
	    reply(550, "Can't set uid.");
	    goto bad;
	}
	home = pw->pw_dir;		/* home dir for globbing */
	umask(defumask);

	time(&t);
	login_time = t;
	strcpy( ddd,ctime(&t) );
	ddd[24] = 0; /* modify format of ctime() output a bit - kill \n */
	if (!non_anonymous)
	  AccessLogging("L %d %s %d '%s' '%s' %s %s", getpid(), remotehostname, custlocality, ftmpuser, ftmppasswd, ddd, auth_username);
	else
	  AccessLogging("LN %d %s %d '%s' '%s' %s %s", getpid(), remotehostname, custlocality, pw->pw_name, ftmppasswd, ddd, auth_username);
	nice(2); /* Lets put him/her background... */

	return;
bad:
	/* Forget all about it... */
	end_login("Bad passwd");
}
