/*
 * Copyright (c) 1988 The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the University of California, Berkeley.  The name of the
 * University may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 * static char sccsid[] = "@(#)logwtmp.c	5.2 (Berkeley) 9/20/88";
 */

#ifndef lint
static char sccsid[] = "@(#)logwtmp.c	5.2 (Berkeley) 9/22/88";
#endif /* not lint */

#include <stdio.h>
#include <sys/types.h>
#include <sys/fcntl.h>
#include <sys/file.h>
#include <sys/time.h>
#include <sys/stat.h>
#if	defined(SVR4) && !defined(__hpux)
# include <utmpx.h>
#else
# include <utmp.h>
#endif

extern time_t time();
extern char *strncpy();

#define	WTMPFILE	"/var/adm/ftpd-wtmp"

static int fd = 0;

void
logwtmp(line, name, host)
	char *line, *name, *host;
{
#if 0

#if	defined(SVR4) && !defined(__hpux)
	struct utmpx ut;
#else
	struct utmp ut;
#endif
	char filename[sizeof(WTMPFILE)+20];
	struct stat buf;
	static time_t logtime = 0;

	if (logtime == 0) {
	  struct tm *tp;
	  logtime = time(NULL);
	  tp = localtime(&logtime);
	  strcpy(filename,WTMPFILE);
	  if (tp != NULL) {
	    int year = tp->tm_year+1900;
	    int week = (tp->tm_yday/7)+1;
	    int wmod = (tp->tm_yday%7);
	    int wday = (tp->tm_wday+6) % 7;
	    if (wmod < 3 && wday > 3) --week;
	    if (week == 0) {
	      week = 52;
	      if (wmod < 3) --year;
	    }

	    sprintf(filename+strlen(filename),".%04dw%02d",year,week);
	  }
	}

	if (!fd && (fd = open(filename, O_CREAT|O_WRONLY|O_APPEND, 0644)) < 0)
		return;
	if (!fstat(fd, &buf)) {
		strncpy(ut.ut_line, line, sizeof(ut.ut_line));
#ifdef	USG
		strncpy(ut.ut_user, name, sizeof(ut.ut_user));
		time(&ut.ut_time);
#define ftruncate(x,y) {}
#else
		strncpy(ut.ut_name, name, sizeof(ut.ut_name));
#if	defined(SVR4) && !defined(__hpux)
		strncpy(ut.ut_host, host, sizeof(ut.ut_host));
		ut.ut_host[sizeof(ut.ut_host)-1] = 0;
		ut.ut_syslen = strlen(ut.ut_host);
		time(&ut.ut_xtime);
#else
		strncpy(ut.ut_host, host, sizeof(ut.ut_host));
		time(&ut.ut_time);
#endif
#endif
		if (write(fd, (char *)&ut, sizeof(struct utmp)) !=
		    sizeof(struct utmp))
			ftruncate(fd, buf.st_size);
	}
#endif
}
